unit mainform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,dbclass;


type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    fieldlist: TListBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure fieldlistClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OnEditChange(sender:TObject);
    procedure RefreshList;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1:TForm1;
  db:TDbClass;
  costs:array[1..10,1..6] of TEdit;

implementation

{$R *.dfm}

procedure TForm1.OnEditChange(sender:TObject);
var
level,j:integer;
tag:integer;
text:string;
begin
tag:= (sender as TEdit).Tag;
j:=tag mod 10;
level:=tag div 10;
db.GotoLevel(level);
text:=(sender as TEdit).Text;
try
db.costs[j]:=strtoint(Text);
  except
  db.costs[j]:=0;
  end;
end;

procedure TForm1.RefreshList;
var
selected:string;
i,j:integer;
begin
if fieldlist.ItemIndex>=0 then
selected:=fieldlist.Items[fieldlist.itemindex];
if db.FindField(selected,1) then
  for I := 1 to 20 do
  begin
  db.GotoLevel(i);
    for j := 1 to 6 do
      costs[i,j].Text:=inttostr(db[j]);
  end;

end;

procedure TForm1.Button1Click(Sender: TObject);
var
newfield:string;
begin
newfield:=Inputbox('Name','Field name:','');
db.AddField(newfield);
fieldlist.Items:=db.GetFieldList;
fieldlist.ItemIndex:=fieldlist.Items.IndexOf(newfield);
RefreshList;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
selected:string;
begin
if fieldlist.ItemIndex>=0 then
selected:=fieldlist.Items[fieldlist.itemindex];
if db.DeleteField(selected) then
  fieldlist.Items:=db.GetFieldList else
  raise Exception.Create('[Delete click]Field not exist');
fieldlist.ItemIndex:=0;
RefreshList;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
fn:string;
dlg:TOpenDialog;
begin
dlg:=TOpenDialog.Create(self);
dlg.Filter:='MyDBFile|*.data';
if dlg.Execute then
  begin
  fn:=dlg.FileName;
  db.LoadFromFile(fn);
  fieldlist.Items:=db.GetFieldList;
  fieldlist.ItemIndex:=0;
  RefreshList;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
fn:string;
dlg:TSaveDialog;
begin
dlg:=TSaveDialog.Create(self);
dlg.Filter:='MyDBFiles|*.data';
if dlg.Execute then
  begin
  fn:=dlg.FileName;
  db.SaveToFile(fn+'.data');
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
temp:integer;
begin
db.renameField(InputBox('New name:','Name',db.getcurrentfieldname));
temp:=fieldlist.ItemIndex;
fieldlist.Items:=db.GetFieldList;
fieldlist.ItemIndex:=temp;
RefreshList;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
i,j:integer;
begin
for i := 1 to 20 do
  begin
  for j := 1 to 4 do
  costs[i,j].Text:=inttostr(random(100)+100);
  costs[i,5].text:=inttostr(random(2)+1);
  costs[i,6].text:=inttostr(random(30)+10);
  end;

end;

procedure TForm1.fieldlistClick(Sender: TObject);
var
selected:string;
  I,j: Integer;
begin
RefreshList;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
i,j:integer;
data:TCostsData;
begin
db:=TDBClass.Create;
for I := 1 to 20 do
  for j := 1 to 6 do
    begin
    costs[i,j]:=TEdit.Create(self);
    costs[i,j].Parent:=panel1;
    costs[i,j].Width:=60;
    costs[i,j].Height:=20;
    costs[i,j].Top:=i*20;
    costs[i,j].Left:=j*60;
    costs[i,j].Tag:=i*10+j;
    costs[i,j].Text:='0';
    costs[i,j].OnChange:=OnEditChange;
    end;
fieldlist.Items.Text:='';
end;

end.
