unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, CustomizeDlg;

const max = 9999;

type
  tuicontrol = record
    name:string;
    uitype:integer;

    x,y,w,h:integer;
    caption:string;
    color:tcolor;
    parent:string;
  end;

  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Edit6: TEdit;
    Image1: TImage;
    ScrollBox1: TScrollBox;
    GroupBox2: TGroupBox;
    Timer1: TTimer;
    Shape1: TShape;
    ColorDialog1: TColorDialog;
    CheckBox1: TCheckBox;
    Edit7: TEdit;
    Label7: TLabel;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    CheckBox2: TCheckBox;
    ComboBox1: TComboBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    CheckBox3: TCheckBox;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ui:array[0..max] of tuicontrol;
  buffer:tbitmap;
  selected:integer;
  borderx,bordery:integer;

  gridsize:integer = 5;

  ready:boolean = false;
  mode:integer;

  SIGNATURE:string = '"MADE BY KOMRAD 28.11.06"';

  mflag:boolean;
  dmp,lastc:tpoint; // down mouse point
  curbounder : integer;

function rectbycontrol(a:tuicontrol):trect;
procedure uisetpos(var a:tuicontrol;nx,ny:integer);
procedure calcselect;
implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
buffer:=tbitmap.Create;
buffer.Width:=800;
buffer.Height:=600;

image1.Parent.DoubleBuffered:=true;


ui[0].name:='mainwindow';
ui[0].caption:='TEST';
ui[0].uitype:=1;
ui[0].color:=clsilver;
ui[0].x:=30;
ui[0].y:=30;
ui[0].w:=280;
ui[0].h:=200;


ui[1].name:='editbox1';
ui[1].caption:='';
ui[1].uitype:=2;
ui[1].parent:=ui[0].name;
ui[1].color:=clwhite;
ui[1].x:=70;
ui[1].y:=150;
ui[1].w:=80;
ui[1].h:=25;

ui[2].name:='button1';
ui[2].caption:='';
ui[2].uitype:=3;
ui[2].parent:=ui[0].name;
ui[2].color:=clsilver;
ui[2].x:=180;
ui[2].y:=150;
ui[2].w:=45;
ui[2].h:=25;

calcselect;
end;

function childinparentrect(child,parent:tuicontrol):boolean;
var res,res2:trect;
begin
intersectrect(res,  rectbycontrol(child),  rectbycontrol(parent));


res2:=rectbycontrol(child);
if comparemem(@res,@res2,sizeof(trect)) then
result:=true else result:=false;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
buffer.Free;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
if selected=0 then exit;
selected:=selected-1;
calcselect;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
if selected=max then exit;
selected:=selected+1;
calcselect;
end;

function rectbycontrol(a:tuicontrol):trect;
begin
  result:=rect(a.x,a.y,a.x+a.w,a.y+a.h);
end;

function idbyname(name:string):integer;
var i:integer;
begin
result:=-1;

for i:=0 to max do
begin
  if ui[i].uitype<>0 then
  if ui[i].name=name then
  begin
    result:=i;
    exit;
  end;
end;
end;

function ptincontrol(a:tuicontrol;pt:tpoint):boolean;
begin
  result:=ptinrect(rect(a.x,a.y,a.x+a.w,a.y+a.h),pt);
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
form2.showmodal;
end;

procedure drawbounders(a:tuicontrol);
begin
  buffer.Canvas.brush.color:=clblack;

  buffer.Canvas.Rectangle(a.x-3,a.y-3,
                          a.x+3,a.y+3);

  buffer.Canvas.Rectangle(a.x+a.w-3,a.y-3,
                          a.x+a.w+3,a.y+3);

  buffer.Canvas.Rectangle(a.x-3,a.y+a.h-3,
                          a.x+3,a.y+a.h+3);

  buffer.Canvas.Rectangle(a.x+a.w-3,a.y+a.h-3,
                          a.x+a.w+3,a.y+a.h+3);

end;

procedure BevelRect(const R: TRect;color1,color2:tcolor);
  begin
    with buffer.Canvas do
    begin
      Pen.Color := Color1;
      PolyLine([Point(R.Left, R.Bottom), Point(R.Left, R.Top),
        Point(R.Right, R.Top)]);
      Pen.Color := Color2;
      PolyLine([Point(R.Right, R.Top), Point(R.Right, R.Bottom),
        Point(R.Left, R.Bottom)]);
        pen.Color:=clblack;
    end;
  end;

procedure drawcontrol(a:tuicontrol);
begin
case a.uitype of
1: begin
buffer.Canvas.pen.Color:=clsilver;
buffer.Canvas.Brush.Color:=a.color;
buffer.Canvas.Rectangle(a.x,a.y,a.x+a.w,a.y+a.h);
//buffer.Canvas.pen.Color:=clwhite;

buffer.Canvas.Brush.Color:=$ff5050;
buffer.Canvas.Rectangle(a.x,a.y-20,a.x+a.w,a.y+1);
buffer.Canvas.pen.Color:=clblack;
buffer.Canvas.TextOut(a.x+3,a.y-20+3,a.caption);
end;
2: begin

//buffer.Canvas.pen.Width:=2;
buffer.Canvas.Brush.Color:=a.color;
//buffer.Canvas.Rectangle(a.x,a.y,a.x+a.w,a.y+a.h);
buffer.Canvas.Rectangle(a.x,a.y,a.x+a.w,a.y+a.h);
BevelRect(rect(a.x+1,a.y+1,a.x+a.w-2,a.y+a.h-2),clBtnShadow,clBtnHighlight);

buffer.Canvas.Brush.Style:=bsclear;
buffer.Canvas.TextOut(a.x+5,a.y+5,a.caption);
buffer.Canvas.Brush.Style:=bssolid;
//buffer.Canvas.pen.Width:=1;
end;

3: begin
buffer.Canvas.Brush.Color:=a.color;
//buffer.Canvas.Rectangle(a.x,a.y,a.x+a.w,a.y+a.h);
//FrameRect(buffer.Canvas.Handle,rect(a.x,a.y,a.x+a.w,a.y+a.h),buffer.canvas.brush.Handle);
BevelRect(rect(a.x+1,a.y+1,a.x+a.w-2,a.y+a.h-2),clBtnHighlight,clBtnShadow);
buffer.Canvas.pen.Color:=clblack;
buffer.Canvas.Rectangle(a.x+3,a.y+3,a.x+a.w-2,a.y+a.h-2);
buffer.Canvas.Brush.Style:=bsclear;
buffer.Canvas.TextOut(a.x+4,a.y+5,a.caption);
buffer.Canvas.Brush.Style:=bssolid;
buffer.Canvas.pen.Color:=clblack;
end;

4: begin
buffer.Canvas.Brush.Style:=bsclear;
buffer.Canvas.TextOut(a.x,a.y,a.caption);
buffer.Canvas.Brush.Style:=bssolid;
end;

5: begin
buffer.Canvas.Brush.Color:=clwhite;
buffer.Canvas.Rectangle(a.x,a.y,a.x+20,a.y+20);

buffer.Canvas.Brush.Style:=bsclear;
buffer.Canvas.TextOut(a.x+23,a.y,a.caption);
buffer.Canvas.Brush.Style:=bssolid;

if a.caption='1' then
begin
  buffer.Canvas.MoveTo(a.x,a.y);
  buffer.Canvas.LineTo(a.x+20,a.y+20);

  buffer.Canvas.MoveTo(a.x,a.y+20);
  buffer.Canvas.LineTo(a.x+20,a.y);
end;
end;

6: begin

buffer.Canvas.Brush.Color:=a.color;
buffer.Canvas.Rectangle(a.x,a.y,a.x+a.w,a.y+a.h);
BevelRect(rect(a.x+1,a.y+1,a.x+a.w-2,a.y+a.h-2),clBtnShadow,clBtnHighlight);

end;


end;

if a.name=ui[selected].name then
begin

  buffer.Canvas.pen.Mode:=pmXor;
  buffer.Canvas.pen.Style:=psDot;

  buffer.Canvas.pen.color:=clwhite;
  buffer.Canvas.Brush.Style:=bsclear;
  buffer.Canvas.Rectangle(a.x-2,a.y-2,a.x+a.w+1,a.y+a.h+2);
  buffer.Canvas.Brush.Style:=bssolid;
  buffer.Canvas.pen.color:=clblack;
  buffer.Canvas.pen.Style:=psSolid;

  buffer.Canvas.pen.Mode:=pmCopy;


  drawbounders(a);
end;
end;

procedure drawborder;
begin
if mode<>0 then
begin
buffer.Canvas.Brush.Style:=bsclear;
buffer.Canvas.Pen.Color:=clred;
buffer.Canvas.Pen.Style:=psdot;

buffer.Canvas.Rectangle(dmp.x,dmp.y,borderx,bordery);
buffer.Canvas.Pen.Style:=pssolid;
buffer.Canvas.Brush.Style:=bssolid;
buffer.Canvas.Pen.Color:=clblack;
end;
end;


procedure draw;
var i:integer;
begin
  patblt(buffer.Canvas.Handle,0,0,800,600,
  BLACKNESS);
  /////////////////////////////////

  for i:=0 to max do
  if ui[i].uitype<>0 then
  drawcontrol(ui[i]);

  drawborder;

  /////////////////////////////////
  form1.Image1.Canvas.Draw(0,0,buffer);
end;

procedure calcselect;
begin
ready:=false;
form1.edit1.Text:=ui[selected].name;
form1.edit6.Text:=ui[selected].caption;
form1.edit2.Text:=inttostr(ui[selected].x);
form1.edit3.Text:=inttostr(ui[selected].w);
form1.edit4.Text:=inttostr(ui[selected].y);
form1.edit5.Text:=inttostr(ui[selected].h);
form1.edit7.text:=ui[selected].parent;

form1.Shape1.Brush.color:=ui[selected].color;
ready:=true;
end;

function mystrToInt(const S: string): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
end;

procedure applyselect;
begin
ui[selected].name:=form1.edit1.Text;
ui[selected].caption:=form1.edit6.Text;
//ui[selected].x:=mystrtoint(form1.edit2.Text);
ui[selected].w:=mystrtoint(form1.edit3.Text);
//ui[selected].y:=mystrtoint(form1.edit4.Text);
ui[selected].h:=mystrtoint(form1.edit5.Text);

ui[selected].color:=form1.Shape1.Brush.color;

ui[selected].parent:=form1.edit7.text;

uisetpos(ui[selected],mystrtoint(form1.edit2.Text),
mystrtoint(form1.edit4.Text));
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
draw;
sleep(1);

end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
if ready then
applyselect;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
ready:=true;
end;

procedure TForm1.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if colordialog1.Execute then
begin
  shape1.Brush.Color:=colordialog1.Color;

  applyselect;
end;
end;

procedure selectcontrol;
var i:integer;
begin
for i:=0 to max do
if ui[i].uitype<>0 then
if ptincontrol(ui[i],dmp) then
selected:=i;

end;

function getfreeui:integer;
var i:integer;
begin
  for i:=0 to max do
  if ui[i].uitype=0 then
  begin
    result:=i;
    exit;
  end;
  result:=-1;
end;

function generatename(controltype:integer):string ;
var i,c:integer;
name1,curname:string;
flag:boolean;
begin
c:=1;
  case controltype of
    1:name1:='WINDOW';
    2:name1:='EDIT';
    3:name1:='BUTTON';
    4:name1:='LABEL';
    5:name1:='CHECKBOX';
    6:name1:='PANEL';
  end;

while true do
begin
flag:=false;
curname:=name1+inttostr(c);
inc(c);

for i:=0 to max do
begin
  if ui[i].uitype<>0 then
  if ui[i].name=curname then
  begin
    flag:=true;
    break;
  end;
end;

if not flag then break;
end;

result:=curname;

end;


procedure addcontrol(x,y,w,h:integer);
var a,b,i:integer;
begin
if w<5 then w:=70;
if h<10 then h:=25;
b:=-1;


for i:=max downto 0 do
if ui[i].uitype<>0 then
if ptincontrol(ui[i],point(x,y)) then
begin

  b:=i;
  if messagebox(0,pchar('  '+ui[b].name+'?'),'UIedit',mb_yesno)=idyes then
  begin
  //ui[a].parent:=ui[b].name;
  break
  end else b:=-1;

end;


a:=getfreeui;
ui[a].uitype:=mode+1;
ui[a].name:=generatename(mode+1);
ui[a].caption:=ui[a].name;
ui[a].x:=x;
ui[a].y:=y;
ui[a].color:=clbtnface;
ui[a].w:=w;
ui[a].h:=h;
if b=-1 then  ui[a].parent:='' else
ui[a].parent:=ui[b].name;
selected:=a;
calcselect;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var rc:trect;
begin
dmp:=point(x,y);

if mode=0 then
if curbounder>0 then
begin
  mflag:=true;
  exit;
end;


if mode=0 then
selectcontrol;

if mode<>0 then
begin
  borderx:=x;
  bordery:=y;
  mflag:=true;
  exit;
end;

//////////////////////
rc:=rectbycontrol(ui[selected]);

if ui[selected].uitype=1 then
begin
  rc.Top:=rc.Top-20;
  rc.Bottom:=rc.Top+20;
end;

if ptinrect(rc,dmp) then
begin
mflag:=true;

if checkbox3.Checked then
begin

lastc:=point(abs(x-ui[selected].x),abs(y-ui[selected].y));

lastc.X:=(lastc.X div gridsize)*gridsize;
lastc.y:=(lastc.y div gridsize)*gridsize;
end;

if ui[selected].uitype=1 then
lastc.Y:=lastc.Y-20;
end;
//////////////////////


calcselect;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
mflag:=false;

if mode>0 then
begin
addcontrol(dmp.X,dmp.y,x-dmp.X,y-dmp.y);
mode:=0;
combobox1.itemindex:=0;
end;
end;

procedure uisetpos(var a:tuicontrol;nx,ny:integer);
var ox,oy,i,t:integer;
b:tuicontrol;
begin
ox:=nx-a.x;
oy:=ny-a.y;

a.x:=nx;
a.y:=ny;

if form1.CheckBox2.Checked then
begin
t:=idbyname(a.parent);
if t<>-1 then
begin
b:=ui[t];
if not childinparentrect(a,b) then
begin
  if a.w>b.w then a.W:=b.w;
  if a.h>b.h then a.h:=b.h;

  if a.x<b.x then a.x:=b.x;
  if a.y<b.y then a.y:=b.y;

  if a.x+a.w>b.x+b.w then a.x:=  b.x+b.w-a.w;
  if a.y+a.h>b.y+b.h then a.y:=  b.y+b.h-a.h;




end;
end;
end;


for i:=0 to max do
if ui[i].uitype<>0 then
if ui[i].parent=a.name then
begin
  uisetpos(ui[i],ui[i].x+ox,ui[i].y+oy);

end;
calcselect;
end;

function overbounders(a:tuicontrol;pt:tpoint):integer;
var rc:trect;
begin


rc:=rect(a.x-3,a.y-3,a.x+3,a.y+3);
if ptinrect(rc,pt) then
begin
result:=1;
exit;
end;

rc:=rect(a.x+a.w-3,a.y-3,a.x+a.w+3,a.y+3);
if ptinrect(rc,pt) then
begin
result:=2;
exit;
end;

rc:=rect(a.x-3,a.y+a.h-3,a.x+3,a.y+a.h+3);
if ptinrect(rc,pt) then
begin
result:=3;
exit;
end;

rc:=rect(a.x+a.w-3,a.y+a.h-3,a.x+3+a.w,a.y+a.h+3);
if ptinrect(rc,pt) then
begin
result:=4;
exit;
end;

result:=0;
end;


procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

if not mflag then
begin
curbounder :=overbounders(ui[selected],point(x,y));
  case curbounder of
  0:  image1.Cursor:=crdefault;
  1:  image1.Cursor:=crsizenwse;
  2:  image1.Cursor:=crsizenesw;
  3:  image1.Cursor:=crsizenesw;
  4:  image1.Cursor:=crsizenwse;
  end;
end;


if checkbox3.Checked then
begin
  x:=gridsize*(x div gridsize);
  y:=gridsize*(y div gridsize);
end;

if (mode<>0)and(mflag) then
begin
  borderx:=x;
  bordery:=y;
end;


///////////   


///////////  
if (curbounder>0)and(mflag) then
begin
case curbounder of
  1: begin ui[selected].w:=ui[selected].w+(ui[selected].x-x); ui[selected].h:=ui[selected].h+(ui[selected].y-y);   ui[selected].x:=x; ui[selected].y:=y; end;
  2: begin ui[selected].w:=x-ui[selected].x;  ui[selected].h:=ui[selected].h+(ui[selected].y-y);  ui[selected].y:=y; end;
  3: begin ui[selected].w:=ui[selected].w+(ui[selected].x-x);  ui[selected].x:=x; ui[selected].h:=y-ui[selected].y; end;
  4: begin ui[selected].w:=x-ui[selected].x; ui[selected].h:=y-ui[selected].y; end;
  end;



  calcselect;
end;

if ui[selected].w<3 then begin ui[selected].w:=3;calcselect; end;
if ui[selected].h<3 then begin ui[selected].h:=3;calcselect; end;

if (mflag)and(checkbox1.Checked)and(curbounder=0)and (mode=0) then
begin

uisetpos(ui[selected],x-(lastc.x),y-(lastc.y));


end;
end;

procedure delcontrol(idx:integer);
var i:integer;
begin
if idx=0 then
begin
  messageboxa(0,'  0  ','error',mb_iconwarning);
  exit;
end;

if ui[idx].uitype<>0 then
begin
  for i:=0 to max do
  if ui[i].uitype<>0 then
  if ui[i].parent=ui[idx].name then
  begin
    delcontrol(i);
  end;
  zeromemory(@ui[idx],sizeof(ui[idx]));
end;
end;


procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  if messageboxa(handle,'      , ?','warning',mb_yesno)=idyes then
  begin
    delcontrol(selected);
    selected:=0;
  end;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
mode:=4;
borderx:=mouse.CursorPos.x;
bordery:=mouse.CursorPos.y;
dmp.X:=mouse.CursorPos.x;
dmp.y:=mouse.CursorPos.y;
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
close;
end;

procedure saveform(str:string);
var f:textfile;

procedure writecontrol(idx:integer;tab:integer);
var s:string;
i:integer;
b:integer;
begin
if ui[idx].uitype=0 then exit;

  case ui[idx].uitype of
    1:s:='window';
    2:s:='inputbox';
    3:s:='button';
    4:s:='label';
    5:s:='checkbox';
    6:s:='panel';
  end;

b:=idbyname(ui[idx].parent);
if b=-1 then inc(b);

for i:=0 to tab-1 do write(f,#9);
writeln(f,'object '+ui[idx].name+':'+s);


for i:=0 to tab-1 do write(f,#9);
if b=0 then
writeln(f,'left=',ui[idx].x) else
writeln(f,'left=',ui[b].x-ui[idx].x);


for i:=0 to tab-1 do write(f,#9);
if b=0 then
writeln(f,'top=',ui[idx].y) else
writeln(f,'top=',ui[b].y-ui[idx].y);


for i:=0 to tab-1 do write(f,#9);
writeln(f,'width=',ui[idx].w);
for i:=0 to tab-1 do write(f,#9);
writeln(f,'height=',ui[idx].h);
for i:=0 to tab-1 do write(f,#9);
writeln(f,'r=',getrvalue(ui[idx].color));
for i:=0 to tab-1 do write(f,#9);
writeln(f,'g=',getgvalue(ui[idx].color));
for i:=0 to tab-1 do write(f,#9);
writeln(f,'b=',getbvalue(ui[idx].color));
for i:=0 to tab-1 do write(f,#9);
writeln(f,'caption=',ui[idx].caption);

for i:=0 to max do
begin
if ui[i].uitype<>0 then
if ui[i].parent=ui[idx].name then
begin
  writecontrol(i,1);

end;
end;

for i:=0 to tab-1 do write(f,#9);
writeln(f,'end');
for i:=0 to tab-1 do write(f,#9);
writeln(f,'');
end;


begin
assignfile(f,str);
rewrite(f);

writecontrol(0,0);

closefile(f);
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
if savedialog1.Execute then
begin
//messagebox(handle,'   ','',MB_ICONASTERISK);
saveform(savedialog1.FileName);
end;
end;

procedure trimtabs(var s:string);
var a:integer;

begin
while True do
begin

a:=pos(#9,s);
if a>0 then
delete(s,a,1) else
begin
  a:=pos(^T,s);

  if a>0 then
  delete(s,a,1) else exit;

end


end;
end;

procedure loadform(str:string);
var f:textfile;
var s:string;
tmpui:integer;
parentui:string;
//a:integer;
//objnotcompl:boolean;




function wordcount(s:string):integer;
var i,c:integer;
begin
c:=0;
for i:= 1 to length(s) do
begin

  if (s[i]=' ')or (s[i]=':')or(s[i]='=')or(i=length(s)) then
  begin
    c:=c+1;
  end;


end;
result:=c;
end;

function getword(s:string;idx:integer):string;
var i,c,old:integer;
begin
c:=0;
result:='';
old:=1;
for i:= 1 to length(s) do
begin

  if (s[i]=' ')or (s[i]=':')or(s[i]='=')or(i=length(s)) then
  begin
    if c=idx then
    begin
      if i=length(s) then  result:=copy(s,old,i-old+1)
      else result:=copy(s,old,i-old);
      exit;
    end;


    c:=c+1;
    old:=i+1;
  end;


end;
end;


procedure childsetcoord;
var i,a:integer;
begin
for I := 0 to max do
begin
  if ui[i].uitype<>0 then
  begin
  if ui[i].w<5 then ui[i].w:=70;
  if ui[i].h<10 then ui[i].h:=25;


  if ui[i].parent<>'' then
  begin


    a:=idbyname(ui[i].parent);
    if a=-1 then begin ui[i].parent:=''; continue; end;

    ui[i].x:={ui[a].x+}(ui[a].x+ui[i].x);
    ui[i].y:={ui[a].y+}(ui[a].y+ui[i].y);


  end;
end;
end;
end;

procedure loadobject(var f:textfile;parent:string;tmpui:integer);
var s:string;
tmpui2:integer;
begin
while not eof(F) do
begin
readln(f,s);
if s='' then continue;
trimtabs(s);

////////////////////////////////////////////////////////
if uppercase(getword(s,0))='R' then
begin
  ui[tmpui].color:=rgb(strtoint(getword(s,1)),getgvalue(ui[tmpui].color),getbvalue(ui[tmpui].color));
end;

if uppercase(getword(s,0))='G' then
begin
  ui[tmpui].color:=rgb(getrvalue(ui[tmpui].color),strtoint(getword(s,1)),getbvalue(ui[tmpui].color));
end;

if uppercase(getword(s,0))='B' then
begin
  ui[tmpui].color:=rgb(getrvalue(ui[tmpui].color),getgvalue(ui[tmpui].color),strtoint(getword(s,1)));
end;

if uppercase(getword(s,0))='LEFT' then
begin
  ui[tmpui].x:=strtoint(getword(s,1));
end;

if uppercase(getword(s,0))='TOP' then
begin
  ui[tmpui].y:=strtoint(getword(s,1));
end;

if uppercase(getword(s,0))='WIDTH' then
begin
  ui[tmpui].w:=strtoint(getword(s,1));
end;

if uppercase(getword(s,0))='HEIGHT' then
begin
  ui[tmpui].h:=strtoint(getword(s,1));
end;

if uppercase(getword(s,0))='CAPTION' then
begin
  ui[tmpui].caption:=getword(s,1);
end;

if uppercase(getword(s,0))='OBJECT' then
begin
  tmpui2:=getfreeui;
  ui[tmpui2].name:=getword(s,1);

  if uppercase(getword(s,2))='WINDOW' then begin ui[tmpui2].uitype:=1; ui[tmpui2].parent:=''; end;
  if uppercase(getword(s,2))='INPUTBOX' then ui[tmpui2].uitype:=2;
  if uppercase(getword(s,2))='BUTTON' then ui[tmpui2].uitype:=3;
  if uppercase(getword(s,2))='LABEL' then ui[tmpui2].uitype:=4;
  if uppercase(getword(s,2))='CHECKBOX' then ui[tmpui2].uitype:=5;
  if uppercase(getword(s,2))='PANEL' then ui[tmpui2].uitype:=6;
  loadobject(f,ui[tmpui].name,tmpui2);
end;

////////////////////////////////////////////////////////

if uppercase(getword(s,0))='END' then
begin
  ui[tmpui].parent:=parent;
  exit;
end;




end;
end;


begin
///////////////////////////init
parentui:='';
zeromemory(@ui,sizeof(ui));
zeromemory(@tmpui,sizeof(tmpui));
//objnotcompl:=false;
///////////////////////////////
assignfile(f,str);
reset(f);
///////////////////////////////
while not eof(f) do
begin
readln(f,s);
if s='' then continue;
trimtabs(s);

if uppercase(getword(s,0))='OBJECT' then
begin
  tmpui:=getfreeui;
  ui[tmpui].name:=getword(s,1);

  if uppercase(getword(s,2))='WINDOW' then begin ui[tmpui].uitype:=1; ui[tmpui].parent:=''; end;
  if uppercase(getword(s,2))='INPUTBOX' then ui[tmpui].uitype:=2;
  if uppercase(getword(s,2))='BUTTON' then ui[tmpui].uitype:=3;
  if uppercase(getword(s,2))='LABEL' then ui[tmpui].uitype:=4;
  if uppercase(getword(s,2))='CHECKBOX' then ui[tmpui].uitype:=5;
  if uppercase(getword(s,2))='PANEL' then ui[tmpui].uitype:=6;
  loadobject(f,'',tmpui);
end;

if uppercase(getword(s,0))='END' then
begin

end;

{if uppercase(getword(s,0))='OBJECT' then
begin
tmpui:=getfreeui;


//zeromemory(@tmpui,sizeof(tmpui));

ui[tmpui].name:=getword(s,1);
ui[tmpui].parent:='Mainform';

if uppercase(getword(s,2))='WINDOW' then begin ui[tmpui].uitype:=1; ui[tmpui].parent:=''; end;
if uppercase(getword(s,2))='INPUTBOX' then ui[tmpui].uitype:=2;
if uppercase(getword(s,2))='BUTTON' then ui[tmpui].uitype:=3;
if uppercase(getword(s,2))='LABEL' then ui[tmpui].uitype:=4;
if uppercase(getword(s,2))='CHECKBOX' then ui[tmpui].uitype:=5;
if uppercase(getword(s,2))='PANEL' then ui[tmpui].uitype:=6;
//parentui:=ui[tmpui].name;
//objnotcompl:=true;

//a:=getfreeui;
//ui[a]:=tmpui;
end;

if uppercase(getword(s,0))='R' then
begin
  ui[tmpui].color:=rgb(strtoint(getword(s,1)),getgvalue(ui[tmpui].color),getbvalue(ui[tmpui].color));
end;

if uppercase(getword(s,0))='G' then
begin
  ui[tmpui].color:=rgb(getrvalue(ui[tmpui].color),strtoint(getword(s,1)),getbvalue(ui[tmpui].color));
end;

if uppercase(getword(s,0))='B' then
begin
  ui[tmpui].color:=rgb(getrvalue(ui[tmpui].color),getgvalue(ui[tmpui].color),strtoint(getword(s,1)));
end;

if uppercase(getword(s,0))='LEFT' then
begin
  ui[tmpui].x:=strtoint(getword(s,1));
end;

if uppercase(getword(s,0))='TOP' then
begin
  ui[tmpui].y:=strtoint(getword(s,1));
end;

if uppercase(getword(s,0))='WIDTH' then
begin
  ui[tmpui].w:=strtoint(getword(s,1));
end;

if uppercase(getword(s,0))='HEIGHT' then
begin
  ui[tmpui].h:=strtoint(getword(s,1));
end;

if uppercase(getword(s,0))='CAPTION' then
begin
  ui[tmpui].caption:=getword(s,1);
end;

if uppercase(getword(s,0))='END' then
begin
  
end;  }


//showmessage(inttostr(wordcount(s)));
//break;
end;
childsetcoord;
///////////////////////////////
closefile(f);
calcselect;
end;


procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
if opendialog1.Execute then
begin
//messagebox(handle,'   ','',MB_ICONASTERISK);
loadform(opendialog1.FileName);
end;
end;

procedure TForm1.ComboBox1Click(Sender: TObject);
begin
mode:=combobox1.ItemIndex;
borderx:=mouse.CursorPos.x;
bordery:=mouse.CursorPos.y;
dmp.X:=mouse.CursorPos.x;
dmp.y:=mouse.CursorPos.y;


groupbox1.SetFocus;
end;

end.
