unit ueMapSlider;

interface
uses list,gmGlobal;

const
MAPX_L=22;
MAPY_L=17;
// 

LEFT=0;
TOP=1;
RIGHT=2;
DOWN=3;
MAP=4;

type

OnSpriteRender=procedure(id:word;x,y:integer);
OnBoxRender=procedure(id:word;x,y:integer);


PLineRecord=^TLineRecord;
TLineRecord=record
  X1,X2,Y1,Y2:integer;
  r1,g1,b1,r2,g2,b2:word;
end;


PSpriteRecord=^TSpriteRecord;
TSpriteRecord=record
  id:word;
  x,y:integer;
end;





TMapSlider=class
  //curmap:array[-250..250,-250..250] of word;
  lines,sprites:TMyList;
  onBox:OnBoxRender;
  onSprite:OnSpriteRender;

  gmBigMap:TMapData;
  cx,cy:integer;
  dx,dy:integer;

  CELL_SIZE:integer;
  procedure Render;
  function Init:boolean;
  function AddSprite(id:word;dx,dy:integer):boolean;
  function AddLine(x1,y1,x2,y2:integer):boolean;
  function SetMap(var map:TMapData):boolean;

  procedure SetOnBox(handler:OnBoxRender);
  procedure SetOnSprite(handler:OnSpriteRender);
  procedure gmMapDrawMap;



  function Left(d:word=3):boolean;
  function Right(d:word=3):boolean;
  function Up(d:word=3):boolean;
  function Down(d:word=3):boolean;

  function MoveXY(X,Y:integer):boolean;

  constructor Create;
  destructor Destroy;
private
  procedure RenderLine(line:TLineRecord);
  procedure RenderSprite(sprite:TSpriteRecord);
  procedure RenderMap;

  procedure inc_x(delta:integer);
  procedure inc_y(delta:integer);

function CheckLineIntersect(line:TLineRecord;
    var pnts:array of TXyCoord):integer;
function DotInside(X,Y:integer):boolean;
end;

implementation
uses ueMain,gmMap,gmMain,gmUI,kol,mhClipping;

constructor TMapSlider.Create;
begin
  Init;
end;

destructor TMapSlider.Destroy;
begin
  //
end;

function TMapSlider.DotInside(X,Y:Integer):boolean;
begin
  if  (X>dx)and(X<dx+MAPX_L*CELL_SIZE)and
      (Y>dy)and(Y<dy+MAPY_L*CELL_SIZE) then
      result:=true else result:=false;  
end;

function TMapSlider.CheckLineIntersect(line:TLineRecord;
    var pnts:array of TXyCoord):integer;
  function CalcTY(b:real):real;
  begin
  CalcTY:=(b-line.y1)/(line.y2-line.y1);
  end;

  function CalcTX(b:real):real;
  begin
  CalcTX:=(b-line.x1)/(line.x2-line.x1);
  end;

  function GetIntersectX(val:integer;var IntRes:boolean):TXyCoord;
  var
  y,t:real;
  return:TXyCoord;
  begin
  t:=CalcTX(val);
  if (t>0)and(t<1) then
    begin
    y:=line.y1+t*(line.y2-line.y1);
    if (y>dx)and(y<dx+MAPX_L*CELL_SIZE) then
      begin
      IntRes:=true;
      return.X:=dx;
      return.Y:=round(y);
      end else IntRes:=false;
    end else IntRes:=false;
  GetIntersectX:=return;
  end;

  function GetIntersectY(val:integer;var IntRes:boolean):TXyCoord;
  var
  x,t:real;
  return:TXYCoord;
  begin
  t:=CalcTY(val);
  if (t>0)and(t<1) then
    begin
    x:=line.x1+t*(line.x2-line.x1);
    if (x>dx)and(x<dx+MAPX_L*CELL_SIZE) then
      begin
      IntRes:=true;
      return.X:=round(x);
      return.Y:=dy;
      end else IntRes:=false;
    end else IntRes:=false;
  GetInterSectY:=return;
  end;


var
IntExists:boolean;
i,IntCount:integer;
pntres:array[0..1]of TXyCoord;
cur:TXyCoord;
begin
IntExists:=false;
IntCount:=0;
cur:=GetIntersectX(dx,IntExists);
if IntExists then
  begin
    Inc(IntCount);
    cur.X:=0;
    cur.Y:=cur.Y-dy;
    pntres[IntCount]:=cur;
  end;
cur:=GetIntersectX(dx+MAPX_L*CELL_SIZE,IntExists);
if IntExists then
  begin
    Inc(IntCount);
    cur.X:=MAPX_L*CELL_SIZE;
    cur.Y:=cur.Y-dy;
    pntres[IntCount]:=cur;
  end;
cur:=GetIntersectY(dy,IntExists);
if IntExists then
  begin
    Inc(IntCount);
    cur.Y:=0;
    cur.X:=cur.X-dx;
    pntres[IntCount]:=cur;
  end;
cur:=GetIntersectY(dy+MAPY_L*CELL_SIZE,IntExists);
if IntExists then
  begin
    Inc(IntCount);
    cur.Y:=MAPY_L*CELL_SIZE;
    cur.X:=cur.x-dx;
    pntres[IntCount]:=cur;
  end;
for i:=0 to 1 do
  pnts[i]:=pntres[i];
result:=IntCount;
end;

procedure TMapSlider.inc_x(delta:integer);
begin
if (dx+delta<12520)and(dx+delta>-11598) then inc(dx,delta);
end;

procedure TMapSlider.inc_y(delta:integer);
begin
if (dy+delta<12568)and(dy+delta>-37100) then inc(dy,delta);
end;


function VillageExists(x,y:integer;var villname:String):boolean;
  var
  i,j:integer;
  begin
  result:=false;
  for j := 0 to Length(game.players) - 1 do
  for I := 0 to Length(gamedata.vils) - 1 do
    if (game.players[j].vils[i].x=x)and(game.players[j].vils[i].y=y) then
    begin
 //   New(res);
    villname:=(game.players[j].vils[i].name);
    result:=true;
    exit;
    end;
  end;

procedure curGlobalToLocal(x,y:integer;var cx:integer;var cy:Integer);
begin
cx:=(-(dx mod CELL_SIZE)-18+x)div CELL_SIZE+2;
cy:=(-(dy mod CELL_SIZE)+y-18)div CELL_SIZE+3;
end;


function TMapSlider.Left(d:word=3):boolean;
begin
inc_x(-d)
end;

function TMapSlider.Right(d:word=3):boolean;
begin
inc_x(d)
end;

function TMapSlider.Up(d:word=3):boolean;
begin
inc_y(d)
end;

function TMapSlider.Down(d:word=3):boolean;
begin
inc_y(-d)
end;

function TMapSlider.MoveXY(X,Y:integer):boolean;
begin
dx:=x;
dy:=y;
end;
//-------------------------------------------------

procedure TMapSlider.gmMapDrawMap;
var
i,j:integer;
curcellx,curcelly:integer;
renderx,rendery:integer;
villxy:TMyList;
cur:PXYCoord;
villxyl:integer;
villn:string;
curbox:TMapBox;

villinfo:PBoxVill;
begin
villxy:=TMyList.Create;
renderx:=-dx mod CELL_SIZE-CELL_SIZE;
rendery:=-dy mod CELL_SIZE-CELL_SIZE;
curcellx:=dx div CELL_SIZE;
curcelly:=dy div CELL_SIZE;

for i:=1 to MAPY_L do
begin
        for j:=1 to MAPX_L do
        begin
        curbox:=gmBigMap[curcellx,curcelly];
        if curbox.sprite>0 then
         ueRenderSprite(renderx,rendery,CELL_SIZE,CELL_SIZE,curbox.sprite,255)
           else
          begin
            New(cur);
            cur.x:=renderx;
            cur.y:=rendery;
              villinfo:=curbox.data;
            if Assigned(curbox.data) then
              cur.name:=villinfo.name else
              cur.name:='sdsdsd';
            villxy.Push(cur);
            cur:=nil;
          ueRenderSprite(renderx,rendery,
          CELL_SIZE,CELL_SIZE,gmMapSprites[GT_VILLAGE0],255);
           end;
                if (i=cx)and(j=cy)then
                if (gmMain_CursorY>100)and(gmMain_CursorY<550) then

                ueRenderRectangle(renderx,rendery,
                CELL_SIZE,CELL_SIZE,128,128,128,50,true);

        renderx:=renderx+CELL_SIZE;
        inc(curcellx);
        end;
        curcellx:=dx div CELL_SIZE;
        inc(curcelly);
        renderx:=-dx mod CELL_SIZE-CELL_SIZE;
        rendery:=rendery+CELL_SIZE;
end;

if villxy.First<>nil then
repeat
       cur:=villxy.Cur;
       with Cur^ do
        ueRenderFontText(Arial10,name,x+10,y-10,0,0,255,200);
until villxy.Next=nil;


if gmUI_Status<>FORM then
        curGlobalToLocal(gmMain_CursorX,gmMain_CursorY,cx,cy);

curcellx:=dx div CELL_SIZE;
curcelly:=dy div CELL_SIZE;        

ueRenderFontText(arial10,int2str(dx)+' '+int2str(dy),20,20,255,0,0,255);
ueRenderFontText(arial10,int2str(curcellx)+' '+int2str(curcelly),20,40,255,0,0,255);

villxy.Destroy;
end;

//-----------------------------------------------------



procedure TMapSlider.RenderMap;
begin
// 
end;

{procedure TMapSlider.RenderLine(line:TLineRecord);
var
pnts:array[0..1]of TXYcoord;
cur:TXyCoord;
intcnt:integer;
needdraw:boolean;
x1,x2,y1,y2:integer;
begin
intcnt:=CheckLineIntersect(line,pnts);
case intcnt of
  2:
    begin
      x1:=pnts[0].X;
      x2:=pnts[1].X;
      y1:=pnts[0].Y;
      y2:=pnts[1].Y;
      needdraw:=true;
    end;
  1:if DotInside(line.X1,line.Y1) then
    begin
    x1:=line.X1-dx;
    x2:=pnts[0].X;
    y1:=line.X1;
    y2:=pnts[0].Y-dy;
    needdraw:=true;
    end else
      if DotInside(line.X2,line.Y2) then
      begin
      x1:=line.X2-dx;
      x2:=pnts[0].X;
      y1:=line.y1-dy;
      y2:=pnts[0].Y;
      needdraw:=true;
      end else needdraw:=false;
  0:if DotInside(line.X1,line.Y1) and DotInside(line.X2,line.Y2) then
    begin
      x1:=line.X1-dx;
      x2:=line.X2-dx;
      y1:=line.Y1-dy;
      y2:=line.Y2-dy;
      needdraw:=true;
    end else needdraw:=false;
end;
if needdraw then
  ueRenderLine(x1,y1,x2,y2,255,0,0,255,0,0,255,100);
//   
end;}// .  

procedure TMapSlider.RenderLine(line: TLineRecord);
var
mLine:TMathLine;
renderXY:array[1..4]of integer;
clipRgn:array[1..4]of integer;
begin
with Line do
  mLine:=TMathLine.Create(x1,y1,x2,y2);
  clipRgn[1]:=dx;
  clipRgn[2]:=dy;
  clipRgn[3]:=dx+MAPX_L*CELL_SIZE;
  clipRgn[4]:=dy+MAPY_L*CELL_SIZE;
  if  mLine.ClipRect(clipRgn[1],clipRgn[2],clipRgn[3],clipRgn[4])>0 then
  begin
    with mLine do
      begin
        renderxy[1]:=round(x1)-dx;
        renderxy[2]:=round(y1)-dy;
        renderxy[3]:=round(x2)-dx;
        renderxy[4]:=round(y2)-dy;
      end;
  ueLineWidth(3);
    ueRenderLine(renderxy[1],renderxy[2],
                  renderxy[3],renderxy[4],
                  255,0,0,255,0,255,0,255);
    ueRenderFontText(
    arial10,int2str(renderxy[1])+' '+int2str(renderxy[2])
    +' | '+int2str(renderxy[3])+' '+int2str(renderxy[4]),20,60,255,0,0,255);
    ueRenderFontText(
    arial10,int2str(clipRgn[1])+' '+int2str(clipRgn[2])
    +' | '+int2str(clipRgn[3])+' '+int2str(ClipRgn[4]),220,60,255,0,0,255);
  ueLineWidth(1);
  end;
end;


procedure TMapSlider.RenderSprite(sprite:TSpriteRecord);
begin
//  
end;

procedure TMapSlider.Render;
var
curline:PLineRecord;
cursprite:PSpriteRecord;
begin
gmMapDrawMap;
curline:=lines.First;
  while Assigned(curline) do
  begin
  RenderLine(curline^);
  curline:=lines.Next;
  end;
cursprite:=sprites.First;
  while Assigned(cursprite) do
  begin
    RenderSprite(cursprite^);
    with cursprite^ do
      onSprite(id,x,y); 
    cursprite:=sprites.Next;
  end;
end;

function TMapSlider.Init:boolean;
begin
lines:=TMyList.Create;
sprites:=TMyList.Create;
cell_size:=50;
AddLine(0,0,10000,20000);
end;

function TMapSlider.AddSprite(id:word;dx,dy:integer):boolean;
var
r:PSpriteRecord;
begin
New(r);
r.id:=id;
r.x:=dx;r.y:=dy;
sprites.Push(r);
result:=true;
end;

function TMapSlider.AddLine(x1,y1,x2,y2:integer):boolean;
var
r:PLineRecord;
begin
New(r);
r.X1:=x1;
r.X2:=x2;
r.Y1:=y1;
r.Y2:=y2;
lines.Push(r);
result:=true;
end;

function TMapSlider.SetMap(var map:TMapData):boolean;
var
i,j:integer;
begin
for i:=-250 to 250 do
 for j:=-250 to 250  do
  gmBigmap[i,j]:=map[i,j];
result:=true;
end;

procedure TMapSlider.SetOnBox(handler:OnBoxRender);
begin
  onBox:=handler;
end;

procedure TMapSlider.SetOnSprite(handler:OnSpriteRender);
begin
  onSprite:=handler;
end;


end.
