unit CSClipping;

interface

function V_CSclip (x0, y0, x1, y1:real):integer;

var
LB_t0, LB_t1:real;
Wxlef,   //*     */
Wybot,   //*     */
Wxrig,   //*                    */
Wytop:real;


implementation


//0.18.4 V_CSclip -  -



{/*--------------------------------------------------- V_CSclip
*    - 
*    
*
* int V_CSclip (float *x0, float *y0, float *x1, float *y1)
*
*  ,    
*  (x0,y0), (x1,y1),   , 
*   Wxlef, Wybot, Wxrig, Wytop
*
*     ,
*      
*  :
*

 *  1001 | 1000 | 1010
 *  -----|------|-----
 *       |  |
 *  0001 | 0000 | 0010
 *  -----|------|-----
 *  0101 | 0100 | 0110
 *


*          0000
*        0,  
*       .
*      = 0,  
* .        .
*      
*    ,     
*      .
*      
*  ,      
*  .
*  ,    .
*       
*    .   ,
*       .
*       ,
*   ,   ,   
*     .
*
*   Code   
*   .
*
*/  }


var
 CSxn, CSyn:real; //*    */


function CSCode :integer; //*    xn, yn */
var
i:integer;
begin
i:= 0;
if (CSxn < Wxlef)then  inc(i) else
  if (CSxn > Wxrig) then inc(i,2);
if (CSyn < Wybot) then inc(i,4) else
  if (CSyn > Wytop)then inc(i,8);
result:=i;
end; //* CScode */


function V_CSclip (x0, y0, x1, y1:real):integer;
label
ex,all;
var
CSxk, CSyk:real; //*    */
cn, ck, //*    */
visible, //* 0/1 -  /*/
ii, s:integer; //*   */
dx, dy, //*  */
dxdy,dydx, //*     */
r:real; //*   */

begin


CSxk:= x1; CSyk:= y1;
CSxn:= x1; CSyn:= y1; ck:= CScode ();
CSxn:= x0; CSyn:= y0; cn:= CScode ();


{*      
*  .      ,
*    ,   
*/}
dx:= CSxk - CSxn;
dy:= CSyk - CSyn;
if (dx <> 0)then dydx:= dy / dx else begin
  if (dy = 0) then begin
   if (cn=0)and(ck=0) then
    goto ex else goto all;
end;
end;
if (dy <> 0)then dxdy:= dx / dy;


//*    */
visible:= 0; ii:= 4;
repeat
  if (cn>0) and (ck>0) then break; //*    */
  if (cn = 0) and (ck = 0) then begin //*    */
  inc(visible); break;
  end;
if (not cn>0) then begin //*  Pn  ,  */
s:= cn; cn:= ck; ck:= s; //*   Pn,Pk  */
r:=CSxn; CSxn:=CSxk; CSxk:=r; //*  ,  Pn */
r:=CSyn; CSyn:=CSyk; CSyk:=r; //*    */
end;
//*   . Pn   
//*     .
//*/
if ((cn and 1)>0) then begin //*     */
CSyn:= CSyn + dydx * (Wxlef-CSxn);
CSxn:= Wxlef;
end else if ((cn and 2)>0) then begin  //*    */
CSyn:= CSyn + dydx * (Wxrig-CSxn);
CSxn:= Wxrig;
end else if ((cn and 4)>0) then begin //*    */
CSxn:= CSxn + dxdy * (Wybot-CSyn);
CSyn:= Wybot;
end else if ((cn and 8)>0) then begin //*   */
CSxn:= CSxn + dxdy * (Wytop-CSyn);
CSyn:= Wytop;
end;
cn:= CScode (); //*    Pn */
dec(ii);
until(ii < 0);
if (visible>0) then begin
ex: x0:= CSxn; y0:= CSyn;
x1:= CSxk; y1:= CSyk;
end;
all:
result:=visible;
end; //* V_CSclip */

end.
