unit myClipping;

interface
type
TXYStruct=record
x,y:real;
end;

function ClipLineEx(var x1,y1,x2,y2:real):integer;


var
LB_t0, LB_t1:real;
Wxlef,   //*     */
Wybot,   //*     */
Wxrig,   //*                    */
Wytop:real;

implementation

function clipTest(p, q:real; var u1,u2:real):integer;
var
r:real;
retval:integer;
begin
  retval := 1;

  if (p < 0.0)then
  begin
    r := q / p;
    if (r > u2)then
      retval := 0
    else if (r > u1)then
      u1 := r;
  end
  else if (p > 0.0)then
  begin
    r := q / p;
    if (r < u1)then
      retval := 0
    else if (r < u2)then
      u2 := r;
  end
  else
  //* p = 0, so line is parallel to this clipping edge */
    if(q < 0.0)then
    //* Line is outside clipping edge */
      retval := 0;

  result:= retval;
end;


function clipLine(var winMin,winMax,p1,p2:TXYStruct):integer;
var
u1,u2,dx,dy:real;
begin
result:=0;
  u1 := 0.0; u2 := 1.0; dx := p2.x - p1.x;

  if (clipTest (-dx, p1.x - winMin.x, u1, u2))>0 then
    if(clipTest (dx, winMax.x - p1.x, u1, u2))>0 then
      begin
      dy := p2.y - p1.y;
      if (clipTest (-dy, p1.y - winMin.y, u1, u2))>0 then
        if(clipTest (dy, winMax.y - p1.y, u1, u2))>0 then
      	begin
        if (u2 < 1.0)then
	          begin
            p2.x := p1.x + u2 * dx;
            p2.y := p1.y + u2 * dy;
            result:=1;
            end;
          if (u1 > 0.0)then
	          begin
            p1.x :=p1.x+ u1 * dx;
            p1.y :=p1.y+ u1 * dy;
            result:=1;
	          end;
          //* lineDDA (ROUND(p1.x), ROUND(p1.y), ROUND(p2.x), ROUND(p2.y)); */
          {glVertex2i(ROUND(p1.x), ROUND(p1.y));
          glVertex2i(ROUND(p2.x), ROUND(p2.y));}
       end;
    end;
end;

function ClipLineEx(var x1,y1,x2,y2:real):integer;
var
a,b,c,d:TXYStruct;
begin
a.x:=WxLef;
a.y:=WyTop;
b.x:=WxRig;
b.y:=WyBot;

c.x:=x1;
c.y:=y1;

d.x:=x2;
d.y:=y2;

result:=ClipLine(a,b,c,d);

x1:=c.x;
x2:=d.x;
y1:=c.y;
y2:=d.y;
end;


end.
