unit gmCity;

interface
uses gmUI,gmGlobal;

type
MPArray=array[1..7] of MyPoint;
TUIBuildForm=class(TUIForm)
n:integer;buildfield:integer;res:integer;
treeview:boolean;
off:integer;
tree:word;scrollbtnsprites:array[1..2]of word;
buttons:array of word;
treeoverarea:word;
procedure SetTreeState(treeval:boolean);
procedure CreateButtons(all:boolean=false);
procedure DestroyButtons(all:boolean=false);
procedure CreateTree;
procedure DestroyTree;
procedure Hide;
end;


var
gmCity_Background:word;
temp:integer;
gmCityBuildBtns:array[1..21] of Word;
gmCityBtnSprites:array[1..30] of Word;// 
gmArmySprites:array[1..3,1..10]of word;
gmCityBuildings:array[1..20]of word;
cur:integer;
treesprite:word;
scrollbar:array[1..4]of word;
buildform:TUiBuildForm;
buildinfo,upgrade//Main interface forms
:TUIForm;
researchform,armoryform:TUIForm;
quickinfo:TUiForm;
constructing:boolean=false;

BUILD_LIST:array[0..MAX_BUILDINGS+5]of boolean;
LEVELS:array[-2..MAX_BUILDINGS+5] of Integer;

{SCROLL CONST}
const
SCROLL_UP=1;
SCROLL_DOWN=2;
SCROLL_BODY=3;
SCROLL_BUTTON=4;

CLAY=2;
WOOD=1;
IRON=3;
CROP=4;

ROMAN=1;
GALLS=2;
TEUTS=3;
{/End}

procedure gmCityInit;
procedure gmCityRun;
procedure gmCityDeInit;

procedure gmCityGameDataLoad;
procedure gmCityGameDataSave;

procedure GenerateBuildList;

procedure gmCityOnBuildBtnDraw(Id:word;X,Y:integer;Width,Height:word);
procedure gmCityOnBuildBtnClick(Id:word);

//    
const
city_X:array[1..20]of Real = (
{1}0.289, 0.245, 0.186, 0.227, 0.362,
{2}0.332, 0.559, 0.589, 0.716, 0.819,
{3}0.810, 0.794, 0.683, 0.544, 0.433,
{4}0.369, 0.436, 0.369, 0.525, 0.491 );

    {1}    {2}    {3}    {4}    {5}
city_Y:array[1..20]of Real = (
{1}0.287, 0.381, 0.534, 0.624, 0.706,
{2}0.766, 0.793, 0.727, 0.649, 0.574,
{3}0.440, 0.355, 0.248, 0.202, 0.234,
{4}0.39 , 0.445, 0.507, 0.353, 0.613);

RallyX:array[1..9] of integer =(330,360,382,370,327,313,330,335,342);
RallyY:array[1..9] of integer =(293,326,277,230,197,225,245,260,270);
var
RallyXY:array of MyPoint;

implementation
uses
KOL,
ueTypes,ueMain,gmMain,gmVillage,windows,gmTimeCalc,
frmSendTroops,frmBarraks,frmBlackSmith,frmHelpForm,frmPause,
gmMap;

procedure gmCityGameDataSave;
var
i:integer;
begin
     for i:=1 to 20 do
     gamedata.vils[0].city.buildings[i].index:=gmUIGetValue(gmCityBuildBtns[i],'building');
end;

procedure gmCityGameDataLoad;
var
i:integer;
begin
for i:=1 to 20 do
        gmUISetValue(gmCityBuildBtns[i],'building',gamedata.vils[0].city.buildings[i].index);

end;




//   
procedure GenerateBuildList;
var
i:integer;
begin
for i:=0 to MAX_BUILDINGS do
BUILD_LIST[i]:=false;
BUILD_LIST[GRANARY]:=(LEVELS[MAIN]>=1)and((LEVELS[GRANARY]=0)or(LEVELS[GRANARY]=20));//1
BUILD_LIST[WAREHOUSE]:=(LEVELS[MAIN]>=1)and((LEVELS[WAREHOUSE]=0)or(LEVELS[WAREHOUSE]=20));//2
BUILD_LIST[CRANNY]:=(LEVELS[MAIN]>=1)and((LEVELS[CRANNY]=0)or(LEVELS[CRANNY]=20));            //3
BUILD_LIST[EMBASSY]:=(LEVELS[MAIN]>=1)and(LEVELS[EMBASSY]=0);                                    //4
BUILD_LIST[BARRACKS]:=(LEVELS[MAIN]>=3)and(LEVELS[RALLY]>=1)and(LEVELS[BARRACKS]=0);                //5
BUILD_LIST[MARKETPLACE]:=(LEVELS[MAIN]>=3)and(LEVELS[MARKETPLACE]=0);                                  //6
BUILD_LIST[PALACE]:=(LEVELS[MAIN]>=5)and(LEVELS[PALACE]=0)and(LEVELS[RESIDENCE]=0)and(LEVELS[EMBASSY]>=1);//7
BUILD_LIST[RESIDENCE]:=(LEVELS[MAIN]>=5)and(LEVELS[PALACE]=0)and(LEVELS[RESIDENCE]=0);                       //8
BUILD_LIST[ACADEMY]:=(LEVELS[BARRACKS]>=3)and(LEVELS[ACADEMY]=0); //9
BUILD_LIST[ARMOURY]:=(LEVELS[ACADEMY]>=1)and(LEVELS[ARMOURY]=0);     //10
BUILD_LIST[BLACKSMITH]:=(LEVELS[ACADEMY]>=3)and(LEVELS[BLACKSMITH]=0);   //11
BUILD_LIST[STABLE]:=(LEVELS[BLACKSMITH]>=3)and(LEVELS[ACADEMY]>=5)and(LEVELS[STABLE]=0); //12
BUILD_LIST[TRADE_OFFICE]:=(LEVELS[MARKETPLACE]=20)and(LEVELS[STABLE]>=10)and(LEVELS[TRADE_OFFICE]=0); //13
BUILD_LIST[WORKSHOP]:=(LEVELS[ACADEMY]>=10)and(LEVELS[WORKSHOP]=0)and(LEVELS[MAIN]>=5);             //14
BUILD_LIST[TOWNHALL]:=(LEVELS[ACADEMY]>=10)and(LEVELS[MAIN]>=10)and(LEVELS[TOWNHALL]=0);               //15
BUILD_LIST[TREASURE_CHAMBER]:=(LEVELS[PALACE]=20)and(LEVELS[MAIN]=20)and(LEVELS[TREASURE_CHAMBER]=0);   //16
BUILD_LIST[WOOD_MILL]:=(LEVELS[WOOD_MILL]=0)and(MAXPITLEVEL[WOOD]>=10);                                     //17
BUILD_LIST[CLAY_MILL]:=(LEVELS[CLAY_MILL]=0)and(MAXPITLEVEL[CLAY]>=10);                                     //18
BUILD_LIST[IRON_MILL]:=(LEVELS[IRON_MILL]=0)and(MAXPITLEVEL[IRON]>=10);                                     //19
BUILD_LIST[CROP_MILL]:=(LEVELS[CROP_MILL]=0)and(MAXPITLEVEL[CROP]>=5);                                      //20
BUILD_LIST[BAKERY]:=(LEVELS[BAKERY]=0)and(LEVELS[CROP_MILL]>=5)and(MAXPITLEVEL[CROP]>=10);                   //21
BUILD_LIST[TOURNAMENT_SQR]:=(LEVELs[RALLY]=10)and(LEVELS[TOURNAMENT_SQR]=0);   //22
BUILD_LIST[GREAT_STABLE]:=(LEVELS[STABLE]=20)and(LEVELS[GREAT_STABLE]=0);  //23
BUILD_LIST[GREAT_BARRACKS]:=(LEVELS[BARRACKS]=20)and(LEVELS[GREAT_BARRACKS]=0);//24
end;

//---------==== upgrade -   ====-------------------
procedure ClearDialogs;
begin
upgrade.visible:=false;
if Assigned(sendtroops) then
   begin
   sendtroops.Destroy;
   sendtroops:=nil;
   end;
if Assigned(barrackform) then
   begin
   barrackform.Destroy;
   barrackform:=nil;
   end;
if Assigned(blacksmithform) then
   begin
   blacksmithform.Destroy;
   blacksmithform:=nil;
   end;
if Assigned(researchform) then
   begin
   researchform.Destroy;
   researchform:=nil;
   end;
if Assigned(armoryform) then
   begin
   armoryform.Destroy;
   armoryform:=nil;
   end;

end;

procedure OnUpgradeCancelClick(id:word);
begin
ClearDialogs;
end;

procedure OnUpgradeClick(id:word);
var
building:integer;
begin
building:=upgrade['simage'].TEMP;
if  building<>28 then
begin
     if tmUpgradeBuilding(3000, building-1)>0
      then
        begin
        showmessage('Resource deficit(check yours farms and pop)');
        exit;
        end;
     constructing:=true;
//     inc(LEVELS[upgrade['simage'].TEMP-1]);
     end else
         begin
          if tmUpgradeBuilding(3000,RALLY)>0 then
            begin
              showmessage('Resource deficit(check yours farms and pop)');
              exit;
            end;
         constructing:=true;
         end;
     //inc(LEVELS[RALLY]);
GenerateBuildList;
{buildform.DestroyButtons;
buildform.CreateButtons;  }
buildform.hide;
ClearDialogs;
end;
//---------==== ===---------------------------------------------

//------------ BuildFOrm -   --------------------
//    
procedure OnCustomImageDraw(id:word;x,y:integer;width,height:word);
var
index:integer;
begin
 index:= round(gmUIGetValue(id,'building'));
if gmUIIsMouseOver(id) then ueRenderRectangle(x,y,width,height,51,0,0,125,false);
        if gmUIIsFocused(id)then
        begin
        ueRenderRectangle(x,y,width,height,255,153,0,85,true);
        ueRenderRectangle(x-1,y-1,width+2,height+2,102,51,0,100,false);
        buildform['info'].Caption:=Names[index];
        ueRenderFontBox(arial15,INFO[index],400,430,24,25,15,0,0,0,255);
        end;
if BUILD_LIST[index] then
OnImageDraw(id,x,y,width,height);
//ueRenderRectangle(x,y,width,height,255,0,0,0,false);
end;

// 
procedure OnCustomTreeDraw(id:word;x,y:integer;width,height:word);
var
offx:integer;
begin
offx:=gmUIGetValue(id,'offx');
ueRenderRectangle(x,y,width,height,0,0,0,100,false);
ueRenderRectangle(x+2,y+2,width-3,height-3,0,0,0,50,true);
ueRenderCutSprite(x,y,0,round(buildform.off*1.92),width,height,treesprite,255);
end;

// 
procedure OnScrollButtonDraw(id:word;x,y:integer;width,height:word);
begin
if gmUIIsMouseOver(scrollbar[SCROLL_BODY])or(gmUIIsMouseOver(scrollbar[SCROLL_BUTTON])) then
ueRenderSprite(x,y,16,16,buildform.scrollbtnsprites[2],255) else
        ueRenderSprite(x,y,16,16,buildform.scrollbtnsprites[2],255);
end;

//  
procedure OnMouseScroll(id:word;x,y:integer);
begin
if not buildform.treeview then
begin
        gmUISetXY(scrollbar[SCROLL_BUTTON],-1,y+gmUIGetY(scrollbar[SCROLL_BODY]));
        buildform.off:=y;
end;
end;


// 
procedure OnScrollUpClick(id:word);
begin
dec(buildform.off);
if buildform.off<0 then buildform.off:=0;
end;

//   
procedure OnScrollDownClick(id:word);
begin
inc(buildform.off);
if buildform.off>340 then buildform.off:=340;
end;

//   
procedure OnCustomImageClick(id:word);
begin
 buildform.res:=id;
end;

//   
procedure OnBuildCancelClick(id:word);
begin
buildform.DestroyButtons;
buildform.res:=0;
//buildform.DestroyButtons;
buildform.hide;
//gmCityInitEx;
end;



//    
procedure OnBuildTreeClick(id:word);
begin
//buildform.DestroyButtons;
//buildform.visible:=false;
buildform.res:=0;
buildform.treeview:=not buildform.treeview;
buildform.SetTreeState(buildform.treeview);
end;

//   
procedure OnCityBuildBtnPress(id:word);
var
val,i:integer;
begin
if buildform.res<>0 then
begin
gmCityGameDataSave;
val:=gmUIGetValue(buildform.res,'building');
for i:=1 to 20 do
    if gmCityBuildBtns[i]=buildform.buildfield then
    begin
    if tmBuildBuilding(5000,i,val,1)>0 then
      begin
      showmessage('Resource deficit(check yours farms and pop)');
      exit;
      end;
    end;
end;
buildform.DestroyButtons;
buildform.res:=0;
buildform.hide;
end;
//-----------------  BuildForm-------------------------------






//------------------------  -------------------------
procedure gmCityOnBuildBtnClick(Id:word);
var
i:integer;
begin
//showmessage(inttostr(id));
i:=round(gmUIGetValue(id,'building')+1);
if not constructing then
if (gmUIGetValue(id,'building')=0)then
      begin
                for i:=0 to Length(buildform.buttons)-1 do
                        gmUISetVisible(buildform.buttons[i],true);
                buildform.visible:=true;
                buildform.CreateButtons;
                buildform.buildfield:=id;
      end else
          begin
          i:=round(gmUIGetValue(id,'building')+1);
          upgrade.visible:=true;
          gmUI_Modal:=M_RUNNING;
          upgrade.empty:=false;
          upgrade['simage'].DATA:=gmCityBtnSprites[i];
          upgrade['name'].Caption:=NAMES[i-1]+' lvl'+int2str(LEVELS[i-1]);
          upgrade['simage'].temp:=i;
          end;

          case i-1 of
               BARRACKS:
                        begin
                        barrackform:=TUiForm.Create('unittrain.frm');
                        for i:=1 to 3 do
                            barrackform['img'+int2str(i)].DATA:=gmArmySprites[1][i];
                            barrackform['img4'].DATA:=gmArmySprites[1][10];
                            barrackform['img5'].DATA:=gmArmySprites[1][9];
                            barrackform['hide'].OnPress:=OnBarracksHide;
                            barrackform['train'].OnPress:=OnBarrackTrain;
                            barrackform['PANEL1'].OnDraw:=OnBarrackCustomPanelDraw;
                            for i:=1 to 5 do
                            begin
                            barrackform['edit'+int2str(i)].OnMouseMove:=OnBarrackQuickInfo;
                            barrackform['edit'+int2str(i)].OnMouseOver:=OnBarrackQuickEnd;
                            end;
                        end;
               ACADEMY:
                       begin
                       researchform:=TUiForm.Create('research.frm');
                       end;
               BLACKSMITH:
                       begin
                       blacksmithform:=TUiForm.Create('blacksmith.frm');
                       for i:=1 to 10 do
                           blacksmithform['CHECKBOX'+int2str(i)].OnPress:=OnBlackSmithCheckPress;
                       blacksmithform['hide'].OnPress:=OnBlackSmithHide;
                       end;
               ARMOURY:
                       begin
                       armoryform:=TUiForm.Create('armory.frm');
                       for i:=1 to 10 do
                           armoryform['IMAGE'+int2str(i)].DATA:=gmArmySprites[1][i];
                       end;
               WORKSHOP:
                        begin
                        end;

          end;
end;

procedure gmRallyPointDraw(Id:word;X,Y:integer;Width,Height:word);
begin
if LEVELS[RALLY]>0 then
   ueRenderSprite(x-10,y+40,height div 2 ,height div 2,gmCityBtnSprites[28],255);
{       for i:=1 to Length(RallyXY)-2 do
        ueRenderLine(RallyXY[i].x,RallyXY[i].y,RallyXY[i+1].x,RallyXY[i+1].y,255,0,0,255,255,0,0,255);
            ueRenderLine(RallyXY[9].x,RallyXY[9].y,RallyXY[1].x,RallyXY[1].y,255,0,0,255,255,0,0,255);}
end;

procedure gmCityOnRallyPointClick(id:word);
var
b:MyPoint;
i:integer;
begin
b.x:=gmUI_CursorX;
b.y:=gmUI_CursorY;
if (IsInside(RallyXY,b)) then
   begin
          if not constructing then
          begin
          upgrade.visible:=true;
          gmUI_Modal:=M_RUNNING;
          upgrade.empty:=false;
          upgrade['simage'].DATA:=gmCityBtnSprites[28];
          upgrade['name'].Caption:=NAMES[RALLY]+' lvl'+int2str(LEVELS[RALLY]);
          upgrade['simage'].temp:=28;
          end;
          if LEVELs[RALLY]>0 then
             begin
             sendtroops:=TUIForm.Create('sendtroops.frm');
             sendtroops['CHECKBOX1'].OnPress:=OnSendTroopsCheckPress;
             sendtroops['CHECKBOX2'].OnPress:=OnSendTroopsCheckPress;
             sendtroops['CHECKBOX3'].OnPress:=OnSendTroopsCheckPress;
             sendtroops['Hide'].OnPress:=OnSendTroopsHide;
             for i:=1 to 10 do
                begin
                 sendtroops['EDIT'+int2str(i)].Caption:='';
                gmUISetValue(sendtroops['EDIT'+int2str(i)].ID,
                  'alttext',int2str(gamedata.vils[0].army.troops[i]));
                 sendtroops['IMAGE'+int2str(i)].DATA:=gmArmySprites[1][i];
                end;
   //          sendtroops.border:=false;
             end;
   end;
end;

procedure gmCityOnRallyPointOver(Id:word;X,Y:integer);
var
b:MyPoint;
i:integer;
begin
b.x:=gmUI_CursorX;
b.y:=gmUI_CursorY;
if IsInside(RallyXY,b) then
   begin
    for i:=1 to Length(RallyXY)-2 do
        ueRenderLine(RallyXY[i].x,RallyXY[i].y,RallyXY[i+1].x,RallyXY[i+1].y,255,0,0,255,255,0,0,255);
            ueRenderLine(RallyXY[9].x,RallyXY[9].y,RallyXY[1].x,RallyXY[1].y,255,0,0,255,255,0,0,255);
    helpform['overimage'].DATA:=gmCityBtnSprites[28];
    helpform['overimage'].visible:=true;
    helpform['name'].Caption:=NAMES[RALLY]+' lvl'+int2str(LEVELS[RALLY]);
//    helpform['info'].Caption:='Click to upgrade and more';
   end;
end;

procedure gmCityOnBuildBtnDraw(Id:word;X,Y:integer;Width,Height:word);
var
  index:integer;
begin
index:=gmUIGetValue(id,'building');
if index=0 then
ueRenderSprite(x,y,width,height,gmCityBtnSprites[index+1],255)else
ueRenderSprite(x,y,width,height*2,gmCityBtnSprites[index+1],255);
if gmUIIsMouseOver(id) then
ueRenderFontBox(arial10,INFO[index],610,160,20,5,10,0,0,128,255);
//ueRenderRectangle(x,y,width,height,255,0,0,128,false);
end;


procedure gmCityOnBuildBtnOver(Id:word;X,Y:integer);
var
index:integer;
begin
index:=gmUIGetValue(id,'building');
if index=0 then
begin
//helpform['info'].Caption:='Click to construct';
helpform['name'].Caption:=NAMES[index];
helpform['overimage'].visible:=false;
 end else
                                 begin
                                    helpform['overimage'].DATA:=gmCityBtnSprites[index+1];
                                    helpform['overimage'].visible:=true;
                                    helpform['name'].Caption:=NAMES[index]+' lvl'+int2str(LEVELS[index]);
//                                    helpform['info'].Caption:='Click to upgrade and more';
                                    end;

end;
//-----------------------  -------------------------



//---------------------  TBuildForm--------------------------
//  
procedure TUiBuildForm.SetTreeState(treeval:boolean);
var
i:integer;
begin
items['cancel'].visible:=treeval;
items['build'].visible:=treeval;
items['imgpanel'].visible:=treeval;
items['info'].visible:=treeval;
items['lbl1'].visible:=treeval;
gmUISetVisible(buildform.tree,not treeval);
if not treeval then
begin
gmUISetParent(treeoverarea,DIALOG);
items['showtree'].Caption:='Hide tree';
for i:=0 to Length(buildform.buttons)-1 do
        gmUISetVisible(buildform.buttons[i],false);
end else
        begin
        gmUISetParent(treeoverarea,NONE);
        items['showtree'].Caption:='Show tree';
        for i:=0 to Length(buildform.buttons)-1 do
        gmUISetVisible(buildform.buttons[i],true);
        end;
for i:=1 to 4 do
        gmUISetVisible(scrollbar[i],not treeval);
end;

// 
procedure TUiBuildForm.CreateTree;
begin
        tree:=gmUINewImage(0,5,512,350,'tree',OnCustomTreeDraw);
        gmUISetValue(tree,'offx',664);
        gmUISetVisible(tree,false);
        gmUISetParent(tree,DIALOG);
end;

// 
procedure TUiBuildForm.DestroyTree;
begin
gmUIDelete(tree);
end;  

// 
procedure TUiBuildFOrm.Hide;
var
I:Integer;
begin
visible:=false;
for i:=0 to Length(buttons)-1 do
        gmUISetVisible(buttons[i],false);
for i:=1 to 4 do
gmUISetVisible(scrollbar[i],false);
end;

//  
procedure TUIBuildForm.CreateButtons(all:boolean=false);
var
offx,offy:integer;
var
i,curid:integer;
l:integer;
begin
n:=30;l:=0;
for i:=0 to MAX_BUILDINGS-1 do
if BUILD_LIST[i+1] then inc(l);
SetLength(buttons,l);
offx:=x+10;
offy:=y+380;
curid:=0;
for i:=0 to MAX_BUILDINGS-1 do
if BUILD_LIST[i+1]  then
 begin
        buttons[curid]:=gmUINewImage(offx,offy,50,50,'city'+int2str(i+1),OnCustomImageDraw,OnCustomImageClick);
        gmUISetParent(buttons[curid],DIAlOG);
        gmUISetValue(buttons[curid],'building',i+1);
        inc(curid);
        inc(offx,55);
        if offx>350 then
                begin
                offx:=x+10;
                dec(offy,55);
                end;
        end;
       { scrollbar[3]:=gmUINewImage(offx+522,offy+5,16,345,'scrollbody');
        scrollbar[1]:=gmUINewImage(offx+522,offy,16,16,'scrollup');
        scrollbar[2]:=gmUINewImage(offx+522,offy,16,16,'scrolldown');
        scrollbar[4]:=gmUINewImage(offx+522,offy+330,16,16,'scrollbutton1',OnScrollButtonDraw);}
      //  treeoverarea:=gmUINewButton(offx+5,offy+5,512,345,nil,nil,OnMouseScroll);
       // gmUiSetValue(scrollbar[3],'active',false);
//        scrollbtnsprites[1]:=ueRenderAddSprite('scrollbutton1');
//        scrollbtnsprites[2]:=ueRenderAddSprite('scrollbutton2');
  {      for i:=1 to 4 do
        gmUISetParent(scrollbar[i],DIALOG);}

end;

//    
procedure TUIBuildForm.DestroyButtons(all:boolean=false);
var
i:integer;
begin
gmUI_Focus:=-1;
for i:=0 to Length(buttons)-1 do
gmUIDelete(buttons[i]);
buttons:=nil;
end;
//--------------------------------------------------------

//
procedure gmCityInitEx;
var
i:integer;
begin

   //     helpform:=TUiForm.Create('villageinfo.frm');
   //     helpform.border:=false;
        helpform['overimage'].DATA:=gmCityBtnSprites[1];
        helpform['overimage'].visible:=false;

        for i:=1 to 5 do
        helpform['img'+int2str(i)].DATA:=ResourceSprites[i];
        for i := 1 to 9 do
        helpform['troops'+int2str(i)].DATA:=gmArmySprites[1][i];


        //     
{buildinfo:=TUIForm.Create('buildinfo.frm');
buildinfo.border:=false;}
//        buildform['tree'].DATA:=ueRenderAddSprite('tree');
temp:=gmUINewButton(0,0,0,0,nil,nil);//  .  
// 
for i:=1 to 20 do
begin
        gmCityBuildBtns[i]:=gmUINewButton(round(City_X[i]*(gmmain_Width-270))-32,
          round((1-City_Y[i])*(gmMain_Height-64))-16,64,32,gmCityOnBuildBtnDraw,gmCityOnBuildBtnClick,gmCityOnBuildBtnOver);
        gmUISetParent(gmCityBuildBTns[i],APPLICATION);
 //       gmUISetValue(gmCityBuildBtns[i],'building',gamedata.vils[0].city.buildings[i].index);
        end;
        gmCityGameDataLoad;
        gmUISetValue(gmCityBuildBtns[19],'building',MAINBUILDING);

//        gmCityBuildBtns[21]:=gmUINewButton(470,165,110,180,gmRallyPointDraw,gmCityOnRallyPointClick,gmCityOnRallyPointOver);
        gmCityBuildBtns[21]:=
          gmUINewButton(315,190,70,140,gmRallyPointDraw,
            gmCityOnRallyPointClick,gmCityOnRallyPointOver);

        //   
        buildform:=TUIBuildForm.Create('citylevel.frm');
        buildform.buildfield:=0;
        buildform['cancel'].OnPress:=OnBuildCancelClick;
        buildform['showtree'].OnPress:=OnBuildTreeClick;
        buildform['build'].OnPress:=OnCityBuildBtnPress;
        buildform.SetTreeState(true);
        buildform.treeview:=true;
//        buildform.CreateButtons;
        for i:=0 to Length(buildform.buttons)-1 do
            gmUISetVisible(buildform.buttons[i],false);
        buildform.visible:=false;
        buildform.buildfield:=0;
        for i:=1 to 5 do
            buildform['pic'+int2str(i)].DATA:=SmallRes[i];
        //  
        upgrade:=TUIForm.Create('upgrade.frm');
        upgrade['cancel'].OnPress:=OnUpgradeCancelClick;
        upgrade['upgrade'].OnPress:=OnUPgradeClick;
        for i:=1 to 5 do
            upgrade['pic'+int2str(i)].DATA:=SmallRes[i];
        upgrade.visible:=false;
end;

procedure gmCityInit;
var
i,j:integer;
begin
SetLength(RallyXY,10);
for i:=1 to 9 do
begin
     RallyXY[i].x:=RallyX[i];
     RallyXY[i].y:=RallyY[i];
     end;
LEVELS[MAINBUILDING]:=3;//        1
LEVELS[RALLY]:=3;
LEVELS[BARRACKS]:=1;
GenerateBuildList;//   
cur:=random(19)+1;//  ?:)  :(
// 
gmCity_Background:=ueRenderAddSprite('City_BackGround');
// 
SetLength(gamedata.vils,1);
gamedata.vils[0].x:=5;
gamedata.vils[0].y:=6;
gamedata.vils[0].name:='Odessa';
gmBigMap[5,6].sprite:=0;
for i:=1 to 21 do
    gamedata.vils[0].city.buildings[i].index:=0;
gamedata.vils[0].city.buildings[19].index:=MAINBUILDING;
gamedata.vils[0].city.buildings[19].level:=3;
gamedata.vils[0].city.buildings[21].level:=1;
gamedata.vils[0].city.buildings[15].index:=BARRACKS;
gamedata.vils[0].city.buildings[15].level:=1;
for i:=0 to 29 do
        gmCityBtnSprites[i+1]:=ueRenderAddSprite(PChar('city'+int2str(i)));
for i:=1 to 3 do
    for j:=1 to 10 do
        gmArmySprites[i][j]:=ueRenderAddSprite(PChar('army'+int2str(i)+'_'+int2str(j)));
treesprite:=ueRenderAddSprite('tree');
        //   
end;



//
procedure gmCityDeInit;
var
i:integer;
begin
gmCityGameDataSave;
for i:=1 to 21 do
begin
     gmUIDelete(gmCityBuildBtns[i]);
     end;
gmUIDelete(temp);
//helpform.destroy;
end;





procedure gmCityKeyDown(Key:integer);
begin
  case Key of
    VK_LEFT:
      begin
      end;
    VK_RIGHT:
      begin
      end;
    VK_ESCAPE:
    Pausegame;
  end;
end;

procedure gmCityIdle;
var
p:MyPoint;
i:integer;
s:TStackStructure;
begin
//Draw City
    ueRenderRectangle(0,0,gmMain_width,gmMain_Height,
    225,242,208,255,true);
    ueRenderRectangle(0,gmMain_Height-64,gmMain_width,64,
    225,242,208,255,true);

    ueRenderSprite(0,0,gmMain_width-270,gmMain_Height-64,
    gmCity_Background,255);
    gmDrawTop;             //  
                           //--------
    if gmUI_Over=-1 then
    begin
    helpform['overimage'].DATA:=gmCityBtnSprites[28];
    helpform['overimage'].visible:=false;
    end;

    if constructing then
       begin
       helpform['bar1'].visible:=true;
       if tmFindFirst(RT_UPGRADE_STRUCTURE,s) then
              helpform['bar1'].DATA:=round(int((1-s.time/s.totaltime)*100))
              else if tmFindFirst(RT_BUY_STRUCTURE,s) then
                   helpform['bar1'].DATA:=round(int((1-s.time/s.totaltime)*100));
       end else
           begin
           helpform['bar1'].visible:=false;
           end;

       if villconstructing then
       begin
       helpform['bar2'].visible:=true;
       if tmFindFirst(RT_BUY_PIT,s) then
              helpform['bar2'].DATA:=round(int((1-s.time/s.totaltime)*100))
       end else
           begin
          helpform['bar2'].visible:=false;
           end;
    gmUIDraw;// 
    tmRecalcStack;// 
    p.X:=gmUI_CursorX;
    p.Y:=gmUI_CursorY;

 {   ueRenderFontText(Arial15,int2str(p.x),10,20,255,0,0,255);
        ueRenderFontText(Arial15,int2str(p.y),50,20,255,0,0,255);}

    ueREnderSprite(gmMain_CursorX-8,gmMain_CursorY-8,16,16,
    cursor,250);           // 

    for i:=1 to 4 do
    begin
    helpform['cur'+int2str(i)].caption:=int2str(round(int(gamedata.res[i])));
    helpform['prod'+int2str(i)].caption:=int2str(MyResourcesProd[i]);
    end;
    helpform['prod4'].caption:=int2str(MyResourcesProd[4]-gamedata.vils[0].pop);
    helpform['cur5'].Caption:=int2str(gamedata.vils[0].pop);
    for i:=1 to 9 do
    begin
    helpform['LABEL'+int2str(i)].caption:=
      int2str(gamedata.vils[0].army.troops[i]);
    end;
end;

procedure gmCityRun;
begin
gmCityInitEx;
SetOnIdle(gmCityIdle);
SetOnKeyDown(gmCityKeyDown);

end;

end.
