unit gmMap;

interface
uses
gmUI,gmGlobal;

const
// 
MAPX_L=20;
MAPY_L=15;
// 

LEFT=0;
TOP=1;
RIGHT=2;
DOWN=3;
MAP=4;

var
gmOverBtns:array[0..4]of word;
gmCurmap:array[1..MAPX_L,1..MAPY_L]of word;
gmBigMap:TMapData;
cx,cy:integer;
dx,dy:integer;
overticks:integer;
last:integer=0;
lasttick:integer;
mapform:TUIForm;

citysprite:word;

citybtns:array[1..5] of word; 

const// 
//- (10 )
GT_GROUND0=10;
GT_GROUND1=11;
GT_GROUND2=12;
GT_GROUND3=13;
GT_GROUND4=14;
GT_GROUND5=15;
GT_GROUND6=16;
GT_GROUND7=17;
GT_GROUND8=18;
GT_GROUND9=19;
//  - 2 
GT_FOREST0=20;
GT_FOREST1=21;
// - 1 
GT_LAKE0=30;
// - 1 
GT_MOUNT0=40;
// - 1 
GT_VILLAGE0=0;
// -    :)
GT_NONE=0;

var
gmMapSprites:array[0..41]of word;
villsprite:word;
CELL_SIZE:integer=50;

procedure gmMapInit;
procedure gmMapRun;

procedure gmMapOnBtnDraw(id:word;x,y:integer;width,height:word);
procedure gmMapOnBtnOver(id:word;x,y:integer);

procedure gmMapDeInit;
function gmMapGetRandomSprite:word;

procedure gmMapDrawMap;

procedure inc_x(var d:integer;delta:integer);
procedure inc_y(var d:integer;delta:integer);

implementation
uses
KOl,
ueTypes,ueMain,gmMain,gmMenu,windows,gmCity,gmTimeCalc,gmVillage,
frmHelpForm,frmPause,
ueMapSlider;

var
mapRender:TMapSlider;

//======================Dialogs===================================
procedure OnCancelClick(id:word);
begin
        if Assigned(mapform) then
                mapform.Destroy;
end;
//----------------------------------------------------------------

procedure inc_x(var d:integer;delta:integer);
begin
if (d+delta<12520)and(d+delta>-11598) then inc(d,delta);
end;

procedure inc_y(var d:integer;delta:integer);
begin
if (d+delta<12568)and(d+delta>-37100) then inc(d,delta);
end;

function gmMapGetRandomSprite:word;
var
i,j,iresult:integer;
begin
i:=random(100);
case i of
0..94:j:=0;
95..96:j:=1;
97..98:j:=2;
99..100:j:=3;
end;
case j of
        0:iresult:=random(9)+GT_GROUND0;//GROUND
        1:iresult:=random(0)+GT_FOREST0;//FOREST
        2:iresult:=random(0)+GT_LAKE0;//LAKE
        3:iresult:=random(0)+GT_MOUNT0;//MOUNT
end;
result:=gmMapSprites[iresult];
end;

procedure curGlobalToLocal(x,y:integer;var cx:integer;var cy:Integer);
begin
cx:=(-(dx mod CELL_SIZE)-18+x)div CELL_SIZE+2;
cy:=(-(dy mod CELL_SIZE)+y-18)div CELL_SIZE+2;
end;

function VillageExists(x,y:integer;var villname:String):boolean;
  var
  i,j:integer;
  begin
  result:=false;
  for j := 0 to Length(game.players) - 1 do
  for I := 0 to Length(gamedata.vils) - 1 do
    if (game.players[j].vils[i].x=x)and(game.players[j].vils[i].y=y) then
    begin
 //   New(res);
    villname:=(game.players[j].vils[i].name);
    result:=true;
    exit;
    end;
  end;


procedure gmMapDrawMap;
var
i,j:integer;
curcellx,curcelly:integer;
villxy:array of TXYCoord;
villxyl:integer;
villn:string;
begin
SetLength(villxy,0);
villxyl:=0;
for i:=1 to MAPX_L do
        for j:=MAPY_L downto 1 do
        begin
        curcellx:=dx div CELL_SIZE-(i-1);
        curcelly:=dy div CELL_SIZE-(j-1);
        if gmBigMap[curcellx,curcelly].sprite>0 then
        ueRenderSprite(-CELL_SIZE+dx mod CELL_SIZE+(i-1)*CELL_SIZE,-CELL_SIZE+dy mod CELL_SIZE+(j-1)*CELL_SIZE,
          CELL_SIZE,CELL_SIZE,gmBigMap[curcellx,curcelly].sprite,255) else
          begin
          VillageExists(curcellx,curcelly,villn);
          SetLength(villxy,villxyl+1);
          inc(villxyl);
          villxy[villxyl-1].x:=-CELL_SIZE+dx mod CELL_SIZE+(i-1)*CELL_SIZE;
          villxy[villxyl-1].y:=-CELL_SIZE+dy mod CELL_SIZE+(j-1)*CELL_SIZE;
          villxy[villxyl-1].name:=villn;
          ueRenderSprite(-CELL_SIZE+dx mod CELL_SIZE+(i-1)*CELL_SIZE,-CELL_SIZE+dy mod CELL_SIZE+(j-1)*CELL_SIZE,
          CELL_SIZE,CELL_SIZE,gmMapSprites[GT_VILLAGE0],255);
          end;
                if (i=cx)and(j=cy)then
                if (gmMain_CursorY>100)and(gmMain_CursorY<550) then
                
                ueRenderRectangle(-CELL_SIZE+dx mod CELL_SIZE+(i-1)*CELL_SIZE,-CELL_SIZE+dy mod CELL_SIZE+(j-1)*CELL_SIZE,
                                                       CELL_SIZE,CELL_SIZE,128,128,128,50,true);

        //ueRenderRectangle(-CELL_SIZE+dx mod CELL_SIZE+(i-1)*CELL_SIZE,-CELL_SIZE+dy mod CELL_SIZE+(j-1)*CELL_SIZE,CELL_SIZE,CELL_SIZE,255,0,0,255,false);
        end;

for i:=0 to villxyl-1 do
        begin
        with villxy[i] do
        ueRenderFontText(Arial10,name,x+10,y-10,0,0,255,200);
        end;


curcellx:=dx div CELL_SIZE-(cx)+1;
curcelly:=dy div CELL_SIZE-(cy)+1;

if gmUI_Status<>FORM then
        curGlobalToLocal(gmMain_CursorX,gmMain_CursorY,cx,cy);{
ueRenderText(gmMain_Width-150,400,0,PChar(int2str(curcellx)),20,0,0,0,200);
ueRenderText(gmMain_Width-150,450,0,pChar(int2str(curcelly)),20,0,0,0,200);

ueRenderText(gmMain_Width-150,100,0,PChar(int2str(cx)),20,0,0,0,200);
ueRenderText(gmMain_Width-150,150,0,PChar(int2str(cy)),20,0,0,0,200);}

{for i:=0 to 3 do
if gmUIIsMouseOver(gmOverBtns[i]) then
        ueRenderText(gmMain_Width-150,50,0,PChar('over'),20,0,0,0,200);}

//ueRenderRectangle(gmMain_width-250,0,250,gmMain_Height-TOPMENUHEIGHT+18,200,200,200,100,true);
end;

procedure gmMapInit;
var
j,i:integer;
begin
dx:=0;dy:=0;
for i:=GT_GROUND0 to GT_GROUND9 do
        gmMapSprites[i]:=ueRenderAddSprite(PChar('ground'+int2str(i-10)));
for i:=GT_FOREST0 to GT_FOREST1 do
        gmMapSprites[i]:=ueRenderAddSprite(PChar('forest'+int2str(i-20)));
for i:=GT_LAKE0 to GT_LAKE0 do
        gmMapSprites[i]:=ueRenderAddSprite(PChar('lake'+int2str(i-30)));
for i:=GT_MOUNT0 to GT_MOUNT0 do
        gmMapSprites[i]:=ueRenderAddSprite(PChar('mount'+int2str(i-40)));
gmMapSprites[GT_VILLAGE0]:=ueRenderAddSprite('village0');
for i:=-250 to 250 do
        for j:=-250 to 250 do
        begin
        gmBigMap[i,j].sprite:=gmMapGetRandomSprite;
        end;
citysprite:=UeRenderAddSprite('citybtn');
end;

procedure gmOnMapBtnClick(id:word);
begin
//
mapform:=TUiForm.Create('mapclick.frm');
mapform['exit'].OnPress:=OnCancelClick;
end;





procedure gmMapInitEx;
var
i:integer;
begin
mapRender:=TMapSlider.Create;
mapRender.SetMap(gmBigMap);
 //      helpform:=TUiForm.Create('villageinfo.frm');
//        CreateHelpForm;
        helpform['overimage'].DATA:=gmCityBtnSprites[1];
        helpform['overimage'].visible:=false;

        for i:=1 to 5 do
        helpform['img'+int2str(i)].DATA:=ResourceSprites[i];
        for i := 1 to 9 do
        helpform['troops'+int2str(i)].DATA:=gmArmySprites[1][i];
overticks:=1;

//gmCity_Background:=ueRenderAddSprite('City_BackGround');
gmOverBtns[TOP]:= gmUINewButton(0,gmMain_Height-1,gmMain_Width,1,gmMapOnBtnDraw,nil,gmMapOnBtnOver);
gmOverBtns[LEFT]:=gmUINewButton(0,0,18,gmMain_Height,gmMapOnBtnDraw,nil,gmMapOnBtnOver);
gmOverBtns[DOWN]:= gmUINewButton(0,0,gmMain_Width,18,gmMapOnBtnDraw,nil,gmMapOnBtnOver);
gmOverBtns[RIGHT]:= gmUINewButton(gmMain_Width-18,0,18,gmMain_Height,gmMapOnBtnDraw,nil,gmMapOnBtnOver);
gmOverBtns[MAP]:=gmUINewButton(19,19,gmMain_Width-38,gmMain_Height-38-64,nil,gmOnMapBtnClick,nil);
end;

procedure gmMapDeInit;
var
i:integer;
begin
for i:=0 to 4 do gmUiDelete(gmOverBtns[i]);
for i:=1 to 5 do gmUIDelete(citybtns[i]);
mapRender.Destroy;
//helpform.destroy;
end;






procedure gmMapOnBtnDraw(id:word;x,y:integer;width,height:word);
begin
//ueRenderRectangle(x,y,width,height,0,255,255,255,true);
end;

procedure gmMapOnBtnOver(id:word;x,y:integer);
begin
end;


procedure gmMapKeyDown(Key:integer);
begin
  case Key of
    VK_LEFT:
      begin
        maprender.Left;
      end;
    VK_RIGHT:
      begin
        mapRender.Right;
      end;
    VK_UP:
    begin
        mapRender.Up;
    end;
    VK_DOWN:
    begin
        mapRender.Down;
    end;
    VK_ESCAPE:
    PauseGame;
    ord('0'):dec(mapRender.CELL_SIZE);
    ord('9'):inc(mapRender.CELL_SIZE);
  end;
end;

procedure gmMapIdle;
var
i:integer;
s:TStackStructure;
begin
   if constructing then
       begin
       helpform['bar1'].visible:=true;
       if tmFindFirst(RT_UPGRADE_STRUCTURE,s) then
              helpform['bar1'].DATA:=round(int((1-s.time/s.totaltime)*100))
              else if tmFindFirst(RT_BUY_STRUCTURE,s) then
                   helpform['bar1'].DATA:=round(int((1-s.time/s.totaltime)*100));
       end else
           begin
           helpform['bar1'].visible:=false;
           end;

       if villconstructing then
       begin
       helpform['bar2'].visible:=true;
       if tmFindFirst(RT_BUY_PIT,s) then
              helpform['bar2'].DATA:=round(int((1-s.time/s.totaltime)*100))
       end else
           begin
          helpform['bar2'].visible:=false;
           end;

for i:=1 to 4 do
    begin
    helpform['cur'+int2str(i)].caption:=int2str(round(int(gamedata.res[i])));
    helpform['prod'+int2str(i)].caption:=int2str(MyResourcesProd[i]);
    end;
    helpform['prod4'].caption:=int2str(MyResourcesProd[4]-gamedata.vils[0].pop);
    helpform['cur5'].Caption:=int2str(gamedata.vils[0].pop);
    for i:=1 to 9 do
    begin
    helpform['LABEL'+int2str(i)].caption:=
      int2str(gamedata.vils[0].army.troops[i]);
    end;
//Draw City
if last>0 then
dec(overticks,last-GetTickCount);
 last:=GetTickCount;
if overticks>1 then
        begin
        overticks:=0;
        for i:=0 to 3 do
        if gmUIIsMouseover(gmOverBtns[i]) then
        case i of
                TOP:mapRender.Up;
                DOWN:mapRender.Down;
                LEFT:mapRender.Left;
                RIGHT:mapRender.Right;
                end;
        end;


    ueREnderRectangle(0,0,gmMain_width,gmMain_Height,
    128,128,128,128,
    true);

   // gmMapDrawMap;
   mapRender.Render;

    gmDrawTop;
//    ueRenderTextRect(gmMain_Width-200,gmMain_Height-TOPMENUHEIGHT-40,150,280,0,t,14,255,100,0,150);
    gmUIDraw;
    tmRecalcStack;




 ueREnderSprite(gmMain_CursorX-8,gmMain_CursorY-8,16,16,
    cursor,250);

end;

procedure gmMapRun;
begin
//gmMapInit;
gmMapInitEx;
SetOnIdle(gmMapIdle);
SetOnKeyDown(gmMapKeyDown);
end;

end.
