unit gmTimeCalc;

interface
uses dbclass,gmAI;

const
RT_NONE=0;
RT_BUY_STRUCTURE=1;
RT_BUY_PIT=2;
RT_DEMOLISH_STRUCTURE=3;

RT_BUY_UNIT=4;    // 
RT_UPGRADE_UNIT=5;// 
RT_RESEARCH=6;//
RT_SEND_TROOPS=7;// 
RT_MESSAGE=8;// 
RT_UPGRADE_STRUCTURE=9;// 
RT_BUY_CAVALRY=10;// 
RT_BUY_MACHINES=11;//  (,)
RT_BUT_SETTLERS=12;// ()

type
TBuyStructure=record
      index:word;//   
      building:word;//   
      pop:word;//+    -  
      level:integer;// 
end;
PBuyStructure=^TBuyStructure;
TUpgradeStructure=record
      building:-1..32;//   
      pop:word;//+    -  
end;
PUpGradeStructure=^TUpgradeStructure;
TBuyPit=record
   index:word;
   level:integer;
end;
PBuyPit=^TBuyPit;
PDemolishStructure=^word;
TBuyUnit=record
      unittype:word; // 
      num:integer; //Number
      time:integer;
      end;
PBuyUnit=^TBuyUnit;
TUpgradeUnit=record
      unittype:word;    // , 
      upgradetype:word; //1- 2-
      perc:integer; //Upgrade percent
      end;
PUpgradeUnit=^TUpgradeUnit;
PResearch=^word;
TActionMessage=record
msg:string[255];
end;
PActionMessage=^TActionMessage;
TSendTroops=record
    troops:array[1..10]of integer;//-  
    trooplvls:array[1..10] of word;// 
    fromx,fromy:integer;// 
    x,y:integer; // 
end;
PSendTroops=^TSendTroops;

TStackStructure=record
   datatype:integer;// 
   villindex:word;//     
   time:integer;// .   
   totaltime:integer;//  
   cost:array[1..4]of integer;//.    
   data:Pointer;//      
end;

var
TimeStack:array of TStackStructure;
costdb:TDBClass;
LastTick:integer;
Delta:integer;
paused:boolean;

procedure tmRecalcStack;
procedure tmInit;
procedure tmDeInit;
procedure tmPause;
procedure tmResume;

procedure tmAddToStack(s:TStackStructure);
procedure tmAddTest(time:integer);
procedure tmAddMessage(time:integer;msg:string);
function tmBuildBuilding(time:integer;index,building,level:integer):integer;
function tmBuyUnit(time:integer;unittype,number:integer):boolean;
function tmUpgradeBuilding(time:integer;building:integer):integer;
function tmBuildPit(time:integer;index,level:integer):integer;
function  tmFindFirst(RType:word;var s:TStackStructure):boolean;

implementation
uses Windows,dialogs,gmUI,kol,
gmCity,gmVillage,gmMap,gmGlobal;

//--------------------------------------------------------------------------
procedure tmAddToStack(s:TStackStructure);  //provereno
var
l:integer;
begin
l:=Length(TimeStack);
SetLength(TimeStack,l+1);
TimeStack[l]:=s;
end;

procedure tmAddTest(time:integer);
var
s:TStackStructure;
begin
s.time:=time;
s.villindex:=1;
s.data:=nil;
s.datatype:=RT_NONE;
tmAddToStack(s);
end;

//---------------------------------------------------------------------------
function tmUpgradeBuilding(time,building:integer):integer;
var
m:TUpgradeStructure;
p:PUpgradeStructure;
s:TStackStructure;
begin
costdb.FindField(NAMES[building],LEVELS[building]);
result:=0;
if (not ecSpendResources(costdb[1],costdb[2],costdb[3],costdb[4])) then
  begin
  result:=1;
  exit;
  end else   if (costdb[5]+gamedata.vils[0].pop>MyResourcesProd[4]) then
            begin
              result:=2;
              exit;
            end;
m.building:=building;
s.time:=time;
s.totaltime:=time;
s.datatype:=RT_UPGRADE_STRUCTURE;
New(p);
p^:=(m);
New(s.data);
s.data:=p;
//m1:=(s.data);
tmAddToStack(s);
end;

procedure tmExecuteBuyUnit(p:pointer);
var
pmsg:PBuyUnit;
msg:TBuyUnit;
rec:TTrainUnitRecord;
prec:PTrainUnitRecord;
begin
pmsg:=p;
msg:=pmsg^;
inc(gamedata.vils[0].army.troops[msg.unittype]);
dec(msg.num);
if msg.num>0 then
  tmBuyUnit(msg.time,msg.unittype,msg.num) else
  if msg.num=0 then
  if barrackqueue.size>0 then
    begin
    new(prec);
    prec:=barrackqueue.Pop;
    rec:=prec^;
    tmBuyUnit(rec.time,rec.unittype,rec.num);
    end;

end;

procedure tmExecuteBuildUpgrade(p:Pointer);
var
pmsg:PUpgradeStructure;
msg:TUpgradeStructure;
begin
pmsg:=p;
msg:=pmsg^;
constructing:=false;
inc(LEVELS[msg.building]);
inc(gamedata.vils[0].pop,ecGetUpgradeCosts(msg.building,5));
GenerateBuildList;
end;

//---------------------------------------------------------------------------
function tmBuildPit(time:integer;index,level:integer):integer;
var
m:TBuyPit;
p:PBuyPit;
s:TStackStructure;
j:integer;
begin
j:=curpits[index+1];
costdb.FindField('Pit'+int2str(j),level);
result:=0;
if not ecSpendResources(costdb[1],costdb[2],costdb[3],costdb[4]) then
  begin
  result:=1;
  exit;
  end else
      if(costdb[5]+gamedata.vils[0].pop>MyResourcesProd[4]) then
      begin
      result:=2;
      exit;
      end;
villconstructing:=true;
m.index:=index;m.level:=level;
s.time:=time;
s.totaltime:=time;
s.datatype:=RT_BUY_PIT;
New(p);
p^:=(m);
New(s.data);
s.data:=p;
//m1:=(s.data);
tmAddToStack(s);
end;

function tmBuyUnit(time:integer;unittype,number:integer):boolean;
var
m:TBuyUnit;
p:PBuyUnit;
s:TStackStructure;
begin
  m.unittype:=unittype;m.time:=time;m.num:=number;
  s.time:=time;
  s.totaltime:=time;
  s.datatype:=RT_BUY_UNIT;
  New(p);
  p^:=(m);
  New(s.data);
  s.data:=p;
  //m1:=(s.data);
  tmAddToStack(s);
end;


procedure tmExecutePit(p:Pointer);
var
pmsg:PBuyPit;
msg:TBuyPit;
index,i:integer;
begin
pmsg:=p;
msg:=pmsg^;
villconstructing:=false;
index:=msg.index;
costdb.FindField('Pit'+int2str(curpits[msg.index]),msg.level);
inc(gamedata.vils[0].pop,costdb[5]);
inc(PITLEVEL[index]);
if (PITLEVEL[index])>MAXPITLEVEL[curpits[index+1]] then
   MAXPITLEVEL[curpits[index+1]]:=(PITLEVEL[index]);
GenerateBuildList;
for i:=1 to  Length(PITLEVEL) do
    MyResourcesProd[curpits[i+1]]:=0;
for i:=1 to  Length(PITLEVEL) do
    inc(MyResourcesProd[curpits[i+1]],PITLEVEL[i]*10);
end;


//---------------------------------------------------------------------------
procedure tmAddMessage(time:integer;msg:string);
var
m,m1:TActionMessage;
p:PActionMessage;
s:TStackStructure;
begin
m.msg:=msg;
s.time:=time;
s.totaltime:=time;
s.datatype:=RT_MESSAGE;
New(p);
p^:=(m);
m1:=p^;
New(s.data);
s.data:=p;
//m1:=(s.data);
tmAddToStack(s);
end;

procedure tmExecuteMsg(p:Pointer);
var
pmsg:PActionMessage;
msg:TActionMessage;
begin
pmsg:=p;
msg:=pmsg^;

{gmUISetValue(buildform.buildfield,'building',val);
LEVELS[val]:=1;
GenerateBuildList;     }
end;

//-------------------------------------------------------------------------
function tmBuildBuilding(time:integer;index,building,level:integer):integer;
var
m:TBuyStructure;
p:PBuyStructure;
s:TStackStructure;
begin
costdb.FindField(NAMES[building],level);
//costdb.GotoLevel(level);
result:=0;
if not ecSpendResources(costdb[1],costdb[2],costdb[3],costdb[4]) then
  begin
  result:=1;
  exit;
  end else
      if(costdb[5]+gamedata.vils[0].pop>MyResourcesProd[4]) then
    begin
    result:=2;
    exit;
    end;
constructing:=true;
m.index:=index;
m.building:=building;
m.level:=level;
s.time:=time;
s.totaltime:=time;
s.datatype:=RT_BUY_STRUCTURE;
New(p);
p^:=(m);
New(s.data);
s.data:=p;
//m1:=(s.data);
tmAddToStack(s);
end;

procedure tmBuildStructure(p:Pointer);
var
pmsg:PBuyStructure;
msg:TBuyStructure;
begin
pmsg:=p;
msg:=pmsg^;
constructing:=false;
inc(gamedata.vils[0].pop,ecGetUpgradeCosts(NAMES[msg.building],1,5));
gamedata.vils[0].city.buildings[msg.index].index:=msg.building;
LEVELS[msg.building]:=msg.level;
if page=PAGE_CITY then
gmCityGameDataload;
GenerateBuildList;
//buildform.DestroyButtons;
//buildform.CreateButtons;
//buildform.Hide;
end;
//-------------------------------------------------------------------------



procedure tmClear(i:integer);   //     ...
var
l,j:integer;
begin
case TimeStack[i].datatype of
  RT_BUY_UNIT:
             tmExecuteBuyUnit(TimeStack[i].data);
  RT_MESSAGE:
             tmExecuteMsg(TimeStack[i].data);
  RT_BUY_STRUCTURE:
             tmBuildStructure(TimeStack[i].data);
  RT_BUY_PIT:
             tmExecutePit(TimeStack[i].data);
  RT_UPGRADE_STRUCTURE:
             tmExecuteBuildUpgrade(TimeStack[i].data);
end;
l:=Length(TimeStack);
   for j:=i to Length(TimeStack)-2 do
       TimeStack[j]:=TimeStack[j+1];
   SetLength(TimeStack,l-1);
end;

procedure tmRecalcStack;
var
i:integer;
curL:integer;
begin
if not paused then begin
Delta:=GetTickCount-lasttick;
LastTick:=GetTickCount;
for i:=0 to Length(TimeStack)-1 do
 Dec(TimeStack[i].time,delta);
 i:=0;
 curL:=Length(TimeStack);
 while i<curL do
 if TimeStack[i].time<=0 then
    begin
    tmClear(i);
    inc(i);
    end else inc(i);

//Resources calc;
if Assigned(gamedata.vils) then
  begin
   for i:=1 to 3 do
   gamedata.res[i]:=gamedata.res[i]+MyResourcesProd[i]/60*(delta/1000);
   gamedata.res[4]:=gamedata.res[4]+(MyResourcesProd[4]-gamedata.vils[0].pop)/60*(delta/1000);
  end;
 end;

aiMakeTurn;
end;

function tmFindFirst(RType:word;var s:TStackStructure):boolean;
var
i:integer;
begin
result:=false;
  for i:=0 to Length(TimeStack)-1 do
  if TimeStack[i].datatype=RType then
     begin
     result:=true;
     s:=TimeStack[i];
     exit;
     end;
end;

procedure tmInit;
begin
     SetLength(TimeStack,0);
     costdb:=TDbClass.Create;
     costdb.LoadFromFile('DB\gamedata.data');
     LastTick:=GetTickCOunt;
     paused:=false;
end;

procedure tmPause;
begin
paused:=true;
end;

procedure tmResume;
begin
paused:=false;
lasttick:=GetTickCount;
end;

procedure tmDeInit;
begin
     SetLength(TimeStack,0);
     TimeStack:=nil;
end;


end.
 