unit ueTypes;

interface

uses
  windows;

type
  TKeyStates = array[0..255] of boolean;

  TRenderInfo = record
    Window:HWND;
    DC:HDC;
    RC:HGLRC;
    Width,
    Height:integer;
    Bits:byte;
    end;

  TProc = procedure;
  TChar = procedure(Char:char);
  TKeyDown = procedure(Key:integer);
  TMouseMove = procedure(X,Y:integer);
  TMouseKeyDown = procedure(X,Y:integer;Left,Right:boolean);

  TConsoleVarType = (
    CVT_BOOLEAN,
    CVT_STRING,
    CVT_CARDINAL,
    CVT_INTEGER,
    CVT_WORD,
    CVT_BYTE,
    CVT_SHORTINT,
    CVT_PROC,
    CVT_SINGLE
    );

  TConsoleProc = procedure(const Text:string);
  TConsoleHelpProc = function(const Text:string):string;

  PConsoleVarProc = ^TConsoleVarProc;
  TConsoleVarProc = record
    Next:PConsoleVarProc;
    HelpProc:TConsoleHelpProc;
    Name:string;
    VarType:TConsoleVarType;
    VarReadOnly:boolean;
    case TConsoleVarType of
      CVT_BOOLEAN:(VBoolean:^boolean);
      CVT_STRING:(VString:^string);
      CVT_CARDINAL:(VCardinal:^cardinal);
      CVT_INTEGER:(VInteger:^integer);
      CVT_WORD:(VWord:^word);
      CVT_BYTE:(VByte:^byte);
      CVT_SHORTINT:(VShortInt:^shortint);
      CVT_PROC:(VProc:TConsoleProc);
      CVT_SINGLE:(VSingle:^single);
    end;

  TResourceType = (RT_RESERVED,

                   RT_PACK,
                   RT_BITMAP,
                   RT_WAVE,
                   RT_TEXT,
                   RT_LEVEL,
                   RT_MODEL,
                   RT_SPRITE,
                   RT_MATERIAL,
                   RT_SHADER,
                   RT_DEMO,
                   RT_SCRIPT);

  TResourceExType = (RET_RESERVED,

                     RET_PACK,

                     RET_BMP,
                     RET_PCX,
                     RET_JPG,
                     RET_TGA,
                     RET_GIF,

                     RET_WAV,
                     RET_OGG,
                     RET_MP3,

                     RET_TXT,

                     RET_XSH,//
                     RET_XSP,//
                     RET_XMT,//

                     RET_LVL,

                     RET_XMD,

                     RET_XDM,

                     // Lua
                     RET_XLTXT,//
                     RET_XLBIN// - 
                     );

  TResourceInfo = record
    RName:string;
    RType:TResourceType;
    RExType:TResourceExType;
    RSize:cardinal;

    RSeek:cardinal;
    end;

  TResourceInfo2 = record
    RType:TResourceType;
    RExType:TResourceExType;
    RSize:cardinal;
    end;

  TResourceEnumProc = function(const ResourceInfo:TResourceInfo):boolean;

  TConsoleVarEnumProc = procedure(VarProc:PConsoleVarProc;
    const VarName,VarValue:string);

implementation

end.
